<?php
global $bbs_help;
require_once('./login.php');
$explan = "掲示板を作成する
■ファイルアップロード
■返信
■過去ログ生成
■隠しパラメータ送信によるスパム投稿対策
■スライドロックによるスパム投稿対策
オプションは[[bbs('lock=1|max_log=100|item=thread')]]のように指定
<h2>指定できるオプション</h2>
<dl><dt>item</dt><dd>デフォルトの記事表示順を指定
item=time（投稿順）　item=thread（スレッドごとに表示）</dd></dl>
<dl><dt>max_log</dt><dd>現行ログの保存数。これを超えると過去ログに移動。
例　max_log=50</dd></dl>
<dl><dt>max_past</dt><dd>過去ログに保存する記事数。これを超えると過去ログファイルを新たに作成。
例　max_past=100</dd></dl>
<dl><dt>page_line</dt><dd>1ページに表示する記事数。これを超えると次のページに表示
例　page_line=10</dd></dl>
<dl><dt>lock</dt><dd>スライダで投稿ボタンをロックする　lock=1で表示する
例　lock=1</dd></dl>
<dl><dt>nameless</dt><dd>投稿者名未入力で投稿した場合、表示される名前を指定。'id'にすると、日付とIPアドレスを元にしたIDを表示
例　nameless=id</dd></dl>
<dl><dt>titleless</dt><dd>タイトル未入力で投稿した場合、表示されるタイトルを指定。
例　titleless=タイトルなし</dd></dl>
<dl><dt>allow_ext_str</dt><dd>アップロードできるファイルの拡張子
例　allow_ext_str=jpg,png,gif,pdf,zip</dd></dl>
";

$bbs_help = $explan;
$format = "[[bbs('lock=1|nameless=id')]]";
date_default_timezone_set('Asia/Tokyo');
$history = <<<EOF
ver.1.0		2021.06.02	とりあえず完成。
ver.1.01	2021.06.03	不要な処理を整理。
ver.1.02	2021.06.08	ファイルのアップロードに失敗したときの処理を選択できるように修正。
ver.1.03	2021.06.10	パスワードをクッキーに保存するオプションを追加。
						管理者ページに管理者パスワード変更フォームを追加。
ver.1.031	2021.06.12	投稿者の編集パスワードをクッキーに保存する設定にした場合は、投稿フォームの編集パスワード欄に入力済みの状態にするよう修正。
						この際、index_base.htmlでフィールドのタイプをtextにしていても、passwordに変更する。
ver.1.032	2021.06.15	記事の表示でインデントを反映するように修正。
ver.1.033	2021.06.16	スレッドごとの表示を変更。
ver.1.034	2021.06.23	ブルートフォース攻撃対策処理を追加。
ver.1.035	2021.06.24	file_upload関数内の記述ミスを修正。
ver.1.036	2021.06.28	禁止用語による投稿拒否機能を追加。
ver.1.037	2021.07.03	bmpファイルの処理を変更。過去ログ生成のバグを修正。
ver.1.038	2021.07.04	再編集でタイトルが変わるバグを修正。
ver.1.039	2021.07.07	スパム調査モードの場合フォーム表示のログを取得するよう修正。
ver.1.04	2021.07.13	login関数を修正。再編集リンクを短縮。
ver.1.041	2021.07.14	フォームを隠す設定の場合再編集フォームも隠されるバグを修正。コメント中の <> がサニタイズされていなかったのを修正。
ver.1.042	2021.07.15	過去ログの添付ファイルレイアウトを修正。
ver.1.043	2021.07.19	オートリンクの設定を追加。再編集で添付ファイルが削除できないバグを修正。
ver.1.044	2021.07.20	検索処理と検索結果の表示を変更。
ver.1.045	2021.08.02	拒否投稿編集画面でヒットした禁止ワードと検出結果を色つき表示するようにした。
ver.1.046	2021.08.20	ブルートフォース攻撃対策はlogin.phpを読み込む方式に変更。
ver.1.047	2022.03.18	PHP8.1.2で出るアラートを回避。
ver.1.048	2022.03.27	bmpのサムネールも作成できるように改修。
ver.1.049	2022.03.30	テンプレート編集機能を追加。テンプレートファイルを自動的にバックアップするよう変更。
ver.1.05	2022.04.13	テキストファイルをアップロードした場合、ファイル内容のテキストを表示できるよう修正。
ver.1.051	2022.04.26	添付ファイルの表示位置を記事中で指定できるよう修正。
ver.1.052	2022.04.28	サムネール画像のサイズをinit.phpで設定するように修正。
ver.1.053	2022.05.06	スライドロックの表示を簡潔に変更。
ver.1.054	2022.06.15	登録IPアドレスからの投稿拒否機能を追加。
ver.1.055	2022.06.20	検索処理を変更。
ver.1.056	2022.06.21	プロキシサーバー経由の投稿を拒否できるようにした。
ver.1.057	2022.07.04	カウンター表示機能追加
ver.1.058	2022.09.06	管理者画面でのinit.php編集処理を修正。
ver.1.059	2022.10.05	タグを許可した場合の挙動を修正。カウントアップ処理を変更。
ver.1.060	2023.03.31	ress.min.cssが効いていなかったのを修正。bbs.cssを修正
EOF;

$history = explode("\n",$history);
$version = 0;
foreach ($history as $i) {
	if (preg_match('/ver\.([\d\.]+)/',$i,$matched) ) {
		$ver = $matched[1];
		if ($ver > $version) { $version = $ver ; }
	}
}
require './init.php';
$script = './bbs.php';
$template_path = './index_base.html';
if (!is_dir($datadir)) { mkdir($datadir); }
if (!is_dir('./template')) { mkdir('./template'); }
if (!file_exists('./template/index_base.html')) {
	copy($template_path, './template/index_base.html');
}
if (!$crypt_pass) {
	if (file_exists('./config.cgi')) {
		file_put_contents('./reload_config.txt', "\$crypt_pass=$crypt_pass", LOCK_EX);
		$message .= reload_config();
		$jump = "$script?alert=" . urlencode("<div style=\"color:crimson;\">" . $message . "</div>");
		if (req('noform')) { $jump .= "&noform=" . req('noform'); }
		if (req('sort')) { $jump .= "&sort=" . req('sort'); }
		redirect($jump);
		exit();
	} else {
		$title = '初期設定';
		create_pass();
		if (!$id) { make_id(); }
		$id_dir = article_dir($id);
		if ($id_dir && !is_dir($id_dir)) { mkdir($id_dir); }
		exit();
	}
}
if (!$id) { make_id(); }
$id_dir = article_dir($id);
if ($id_dir && !is_dir($id_dir)) { mkdir($id_dir); }
$bbs_dir = join('/',array($id_dir,'bbs'));
if (! is_dir($bbs_dir)) { mkdir($bbs_dir); }

$html = $template = file_get_contents($template_path);
if (isset($add_header_link) && $add_header_link) {
	$html = $template = str_replace('!add_header_link!',$add_header_link,$html);
} else {
	$html = $template = str_replace('!add_header_link!','',$html);
}
if (req('preview_template')) {
	preview_template();
	exit;
}
print print_html($html);
exit;

function counter_str() {
	global $bbs_dir, $count_seq;

	$count_path = $bbs_dir . '/bbs.count';
	$counter_id = 'bbs_count';
	foreach (array('show_past', 'show_spam', 'search', 'edit_spam', 'edit_ip', 'bbs_admin', 'mode') as $key) {
		if ($key == 'mode') {
			$tmp_path = $bbs_dir . '/' . req($key) . '.count';
			$tmp_id = req($key) . '_count';
		} else {
			$tmp_path = $bbs_dir . '/' . $key . '.count';
			$tmp_id = $key . '_count';
		}
		if (req($key)) {
			$count_path = $tmp_path;
			$counter_id = $tmp_id;
			break;
		}
	}
	$counter = get_counter($counter_id);
	counter($counter_id);
	return($counter);
}

function time_str($tm = '') {
	$d = date_create($tm);
	$time_str = date_format($d, "Y/m/d H:i:s");
	return $time_str;
}


function counter($id) {
	//global $datadir, $count_seq;
	global $bbs_dir, $count_seq, $counter_kuriage;
	$counter_kuriage = 10000;
	$last_count_max = 20;
	$user_ip = $_SERVER['REMOTE_ADDR'];
	if (!$id) { return; }
	if (!file_exists($bbs_dir . '/counter')) { mkdir($bbs_dir . '/counter'); }
	$counter_path = $bbs_dir . '/counter/' . $id . '.cgi';
	$last_count_path = $bbs_dir . '/counter/' . $id . '_ip.cgi';
	if ($count_seq) {
		file_put_contents($counter_path,'1',FILE_APPEND | LOCK_EX);
	} else {
		// 連続アクセスをカウントしない設定の場合、直近20件のアクセス中24時間以内のアクセス履歴がないIPアドレスからのアクセスのみカウントアップする(ロボット対策)
		$ip = '';
		$log = array();
		if (file_exists($last_count_path)) {
			$log = file($last_count_path, FILE_IGNORE_NEW_LINES);
			$line = end($log);
			list($tm,$ip) = explode('<>',$line);
		}
		$count_up = 1;
		foreach (array_reverse($log) as $line) {
			$tm = $ip = '';
			list($tm,$ip) = explode('<>',$line);
			if ($ip && $ip == $user_ip && $tm && time() - strtotime($tm) < 3600*24) {
				$count_up = 0;
				break;
			}
		}
		if ($count_up) {
			file_put_contents($counter_path, '1', FILE_APPEND | LOCK_EX);
			if ($log && count($log) > $last_count_max) {
				$log = array_slice($log,-1 * $last_count_max, $last_count_max);
				file_put_contents($last_count_path, join("\n",$log) . "\n", LOCK_EX);
			}
			file_put_contents($last_count_path, time_str('') . '<>' . $_SERVER['REMOTE_ADDR'] . "\n", FILE_APPEND | LOCK_EX);
		}
	}
	$count = filesize($counter_path);
	if ($count > $counter_kuriage) {
		$counter_kuriage_path[$counter_kuriage] = preg_replace('/\.cgi/', '_' . $counter_kuriage . '.cgi', $counter_path);
		file_put_contents($counter_kuriage_path[$counter_kuriage],'1',FILE_APPEND | LOCK_EX);
		$count -= $counter_kuriage;
		file_put_contents($counter_path, str_repeat('1', $count), LOCK_EX);
	}
}


function get_counter($id) {
	global $bbs_dir, $counter_kuriage;
	$counter_kuriage = 10000;
	$counter_path = $bbs_dir . '/counter/' . $id . '.cgi';
	if (!file_exists($counter_path)) { return; }
	$counter_kuriage_path[$counter_kuriage] = preg_replace('/\.cgi/', '_' . $counter_kuriage . '.cgi', $counter_path);
	if (file_exists($counter_kuriage_path[$counter_kuriage])) {
		$count = filesize($counter_path) + filesize($counter_kuriage_path[$counter_kuriage]) * $counter_kuriage;
	} else {
		$count = filesize($counter_path);
	}
	return($count);
}


function print_html($html) {
	global $script, $alert, $indx, $version, $id, $show_block_list_link, $bbs_dir, $template_path, $template, $article_template, $field_template, $item, $max_log, $max_past, $page_line, $lock, $titleless, $nameless, $allow_ext_str, $t_title, $footer, $max_text_line, $show_counter, $count_seq, $counter_format;
	
	$option_list = array();
	foreach (array('item','max_log','max_past','page_line','lock','titleless','nameless','allow_ext_str') as $key) {
		$option_list[] = $key . '=' . $$key;
	}
	if ($show_counter) { $counter = number_format(counter_str()); }
	$bbs_option = join('|',$option_list);
	preg_match('/(<!-- ?記事開始 ?-->)([\s\S]*)(<!-- ?記事終了 ?-->)/',$html,$match);
	$article_template = $match[2];
	preg_match('/(<!-- ?フィールド開始 ?-->)([\s\S]*)(<!-- ?フィールド終了 ?-->)/',$html,$match);
	$field_template = $match[2];
	$main = bbs($bbs_option);
	$main = str_replace('|n|',"\n",$main);
	if (req('mode') == 'download') {
		download();
		exit;
	} elseif (req('mode') == 'show_bruteforce_log') {
		$html = show_bruteforce_log($bbs_dir. '/login');
		print "<html>\n<head><title>ブルートフォースログ</title>\n</head>\n<body>\n" . $html . "</body>\n</html>\n";
		exit;
	}
	$html = str_replace('!title!',$t_title,$html);
	$html = str_replace('!header!',"<a href=\"$script\">$t_title</a>",$html);
	if (!req('bbs_admin') && !req('bbs_help') && !req('bbs_admin_login')) {
		$html = str_replace('!main!',$main,$html);
	} else {
		$html = str_replace('!form!',$main,$html);
		$html = str_replace('!main!','',$html);
	}
	if (req('show_spam')) {
		$form = $search_form = '';
	} elseif (!req('bbs_admin') && !req('edit_spam') && !req('bbs_help')) {
		list($form,$search_form) = form();
		$form = str_replace('|n|',"\n",$form);
	} else {
		$form = $search_form = '';
	}
	if ($alert) {
		$alert = "<div style=\"padding-left:0.4em;color:crimson;font-weight:bold;\">$alert</div>\n";
	} else {
		$alert = '';
	}
	if (!$indx) { $indx = ''; }
	if (req('show_spam') || req('bbs_admin') && !req('bbs_admin_login') && !req('pass')) {
		$indx = "<span style=\"padding-left:0.4em;\"><a href=\"$script\">戻る</a></span>";
	}
	$form = str_replace('!alert!',$alert,$form);
	$html = str_replace('!form!',$form,$html);
	$html = str_replace('!article_search!',$search_form,$html);
	if ($show_counter && isset($counter)) {
		$counter = preg_replace('/\[\[counter\]\]/', $counter, $counter_format);
		$html = str_replace('!counter!',$counter,$html);
	} else {
		$html = str_replace('!counter!','',$html);
	}
	$html = str_replace('!sub_header!',$indx,$html);

	$history_link = preg_replace('/^\.\//', '', $script) . " <a href=\"$script?mode=history\">version $version</a>";
	//$hash['id'] = $id;
	$hash['bbs_help'] = 1;
	$help_link = "<wbr><a href=\"" . script_link($hash,'bbs') . "\">ヘルプ</a>";
	unset($hash['bbs_help']);
	if ($show_block_list_link && file_exists($bbs_dir . '/bbs_spamlog.cgi') && filesize($bbs_dir . '/bbs_spamlog.cgi') > 0) {
		$help_link .= " <a href=\"$script?show_spam=1\" target=\"_blank\">ブロックした投稿</a>";
	}
	$hash['bbs_admin'] = 1;
	$help_admin = "<div style=\"margin-left:auto;\">$history_link $help_link <a href=\"" . script_link($hash,'bbs') . "\">管理者用</a></div>\n";
	$footer = str_replace('!admin!', $help_admin, footer());
	$html = str_replace('!footer!', $footer, $html);
	$html = preg_replace('/(<!-- ?フィールド開始 ?-->)[\s\S]*(<!-- ?フィールド終了 ?-->)/', '$1' . '$2', $html);
	$html = preg_replace('/(<!-- ?記事開始 ?-->)[\s\S]*(<!-- ?記事終了 ?-->)/', '$1' . '$2', $html);
	if (req('mode') == 'history') {
		history();
		exit;
	}
	preg_match_all('/!<([^<>]+)>!/', $html, $match_list);
	if ($match_list[1]) {
		foreach ($match_list[1] as $match) {
			if (!file_exists($match)) { continue; }
			$cont = file($match, FILE_IGNORE_NEW_LINES);
			if ($max_text_line && count($cont) > $max_text_line) {
				$cont = array_slice($cont, 0, $max_text_line);
				$cont[] = ".......................";
			}
			$cont = join("\n", $cont);
			$code = mb_detect_encoding($cont, "JIS, eucjp-win, sjis-win", "utf-8");
			if ($code && $code != 'utf-8') { $cont = mb_convert_encoding($cont, 'utf-8', $code); }
			$cont = str_replace('<', '&lt;', $cont);
			$cont = str_replace('>', '&gt;', $cont);
			$html = preg_replace('|!<' . $match . '>!|', $cont, $html);
		}
	}
	return $html;
}

function history() {
	global $script, $template, $history, $article_template, $footer, $t_title, $counter, $counter_format;
	
	$title = $t_title . '[更新履歴]';
	$html = preg_replace('/(<!-- ?フィールド開始 ?-->)[\s\S]*(<!-- ?フィールド終了 ?-->)/', '$1' . '$2', $template);
	$html = preg_replace('/(<!-- ?記事開始 ?-->)[\s\S]*(<!-- ?記事終了 ?-->)/', '$1' . '$2', $html);
	$html = str_replace('!header!', "<a href=\"$script\">更新履歴</a>", $html);
	$modoru = "<span style=\"padding-left:0.4em;\"><a href=\"javascript:history.back();\">戻る</a></span>";
	$html = str_replace('!sub_header!', $modoru, $html);
	$html = str_replace('!article_search!', '', $html);
	$html = str_replace('!main!', '', $html);
	$html = str_replace('!footer!', $footer, $html);
	$history = array_reverse($history);
	$count = -1;
	$row = 0;
	$str = '';
	$ptn = '/(class="article"[\s\S]*style=")(margin[^:]*[^;]+;)/';
	$article_template = preg_replace($ptn,'$1',$article_template);
	foreach ($history as $i) {
		$count++;
		$i = preg_replace('/\t+/',"\t",$i);
		if (preg_match('/^ver\./',$i)) {
			list($ver,$date,$cont) = explode("\t",$i);
			if (isset($history_plus[$count])) {
				$cont .= "<br />" . $history_plus[$count];
			}
		} else {
			$i = preg_replace('/^\t/','',$i);
			$add = 0;
			for ($j = 1; $j<=10; $j++) {
				if (preg_match('/^ver\./',$history[$count+$j])) {
					if (!isset($history_plus[$count+$j])) { $history_plus[$count+$j] = ''; }
					$history_plus[$count+$j] = $i . "<br />" . $history_plus[$count+$j];
					$add = 1;
					break;
				}
			}
			if ($add) { continue; }
		}
		if ($row % 2 == 1) {
			$back = '';
		} else {
			$back = ' style="background-color:#ffeebb;"';
		}
		$art = str_replace('!article_title!',$ver,$article_template);
		$art = str_replace('!article_date!',$date,$art);
		$art = str_replace('!article_writer!','',$art);
		$art = str_replace('!article_reply!','',$art);
		$art = str_replace('!article!',$cont,$art);
		$art = str_replace('!attach!','',$art);
		$art = preg_replace('/id ?= ?"!article_id!"/','',$art);
		$str .= $art;
		$row++;
	}
	$html = str_replace('!title!',$title,$html);
	$html = str_replace('!form!',$str,$html);
	$counter = counter_str();
	if (!$counter) { $counter = 0; }
	if (is_int($counter)) { $counter = number_format($counter); }
	$counter = preg_replace('/\[\[counter\]\]/', $counter, $counter_format);
	$html = str_replace('!counter!', $counter, $html);
	print $html;
}


function indent_div($html) {
	time_check('インデントdiv開始');
	//$html = preg_replace('/\r\n?/', "\n", $html);
	$html = str_replace(array("\r\n", "\r"), "\n", $html);
	$list = explode("\n", $html);
	$new_list = array();
	foreach ($list as $line) {
		if (!$line) { continue; }
		$div_pos = strpos($line, '<div', 1);
		while ($div_pos > 0) {
			$div_pos = strpos($line, '<div', 1);
			$str1 = substr($line, 0, $div_pos);
			$line = substr($line, $div_pos);
			$new_list[] = $str1;
		}
		if ($line) {
			$new_list[] = $line;
		}
	}
	$list = $new_list;
	$new_list = array();
	foreach ($list as $line) {
		if (!$line) { continue; }
		$div_pos = strpos($line, '</div', 1);
		while ($div_pos > 0) {
			$div_pos = strpos($line, '</div', 1);
			$str1 = substr($line, 0, $div_pos);
			$line = substr($line, $div_pos);
			$new_list[] = $str1;
		}
		if ($line) {
			$new_list[] = $line;
		}
	}
	$div_lev = 0;
	$list = $new_list;
	$new_list = array();
	foreach ($list as $line) {
		$div_plus = $div_minus = 0;
		$div_plus = substr_count($line, '<div');
		$div_minus = substr_count($line, '</div');
		if ($div_lev > 0 && preg_match('/^</', $line)) {
			if (preg_match('/^<\/div/', $line)) {
				$tab = str_repeat("\t", $div_lev - 1);
			} else {
				$tab = str_repeat("\t", $div_lev);
			}
		} else {
			$tab = '';
		}
		$new_list[] = $tab . $line;
		$div_lev = $div_lev + $div_plus - $div_minus;
	}
	time_check('インデントdiv終了');
	return(join("\n", $new_list) . "\n");
}



function create_pass() {
	global $script;
	if (req('pass')) {
		if (strlen(req('pass')) < 5) {
			error("パスワードは5文字以上にしてください。",'back');
		}
		$init_list = file("./init.php");
		$new_init_list = array();
		foreach ($init_list as $line) {
			$tmp = $line;
			$tmp = str_replace(' ','',$tmp);
			$ptn = '/^\$crypt_pass=\'/';
			if (preg_match($ptn,$tmp)) {		
				// 入力された管理者用パスワードをcryptして$crypt_passに代入する文字列を生成
				$crypt_pass = encrypt(req('pass'));
				$tmp = explode(';',$line);
				$com = array_pop($tmp);
				$new_pass = '$crypt_pass = ' . "'" . $crypt_pass . "';" . $com;
				array_push($new_init_list,$new_pass);
			} else {
				array_push($new_init_list,$line);
			}
		}
		file_put_contents('./init.php', $new_init_list, LOCK_EX);
		// 設定画面に移動する
		$value = '設定';
		$value = urlencode($value);
		make_config();
		$jump = "$script?mode=config&pass=" . req('pass') . "\n\n";
		redirect($jump);
		exit();
	}
	head();
	global $script;
	print "<div style=\"margin:1em;\">\n<p>管理者用パスワードを設定してください。</p>\n";
	print "<form action=\"$script\" method=\"post\">\n";
	print "パスワード&nbsp;<input type=\"password\" name=\"pass\" value=\"\" size=\"10\" style=\"width:12em;\" />\n";
	print "<input type=\"submit\" value=\"登録\" />\n";
	print "</form>\n</div>\n";
	footer();
	print "</body>\n</html>\n";
	exit();
}


function make_config() {
	global $config_list, $script;

	$init_list = file("./init.php");
	$o_init_list = $init_list;
	$new_line_list = array();
	$popup = array();
	$line_count = 0;
	foreach ($init_list as $init_line) {
		$line_flag = 0;
		foreach (array_merge(array('crypt_pass','id','color_list'),$config_list) as $cfg) {
			$next = 0;
			if (isset($invalid) && $invalid) {
				foreach ($invalid as $_) {
					if ($cfg === $_) { $next = 1; }
				}
			}
			$ptn = '/^\$' . $cfg . '( +=|=)+/';
			if ($cfg && preg_match($ptn,$init_line)) {
				if (preg_match('/^\d+$/',req($cfg))) {
					$value = $val = req($cfg);
					$type[$cfg] = '数値';
				} else {
					$val = req($cfg);
					$val = str_replace('&lt;','<',$val);
					$val = str_replace('&gt;','>',$val);
					$val = str_replace('&quot;','"',$val);
					$val = str_replace(array("\r\n","\r","\n"), "\n", $val);
					$val = str_replace("\n", '\n', $val);
					$val = str_replace('"','\"',$val);
					$value = '"' . $val . '"';
					$type[$cfg] = '文字列';
				}
				if ($val == '') {
					eval($init_line);
					if (is_array($$cfg)) {
						$list = array();
						foreach ($$cfg as $_) {
							$list[] = "'" . $_ . "'";
						}
						$str = 'array(' . join(',',$list) . ')';
						$value = $str;
					} else {
						if (preg_match('/^\d+$/',$$cfg)) {
							$value = $$cfg;
						}	else {
							$value = "'" . $$cfg . "'";
						}
					}
				}
				if (!$next) { $config[$cfg] = $value; }
				break;
			}
		}
	}
	$cfg_line = '';
	foreach ($config as $key=>$val) {
		$cfg_line .= "$key<>$val" . "\n";
	}
	file_put_contents('./config.cgi',$cfg_line,LOCK_EX);
}


function reload_config() {
	global $config_list, $script;
	time_check('設定抽出');
	$configs = file('./config.cgi',FILE_IGNORE_NEW_LINES);
	foreach ($configs as $line) {
		list($key,$val) = explode('<>',$line);
		$loaded[$key] = $val;
	}
	$init_list = file('./init.php');
	$line_count = 0;
	$new_init_list = array();
	foreach ($init_list as $line) {
		foreach ($loaded as $key=>$val) {
			$ptn = '/^\$' . $key . '( +=|=)+/';
			if (preg_match($ptn,$line)) {
				$value = $val;
				$tmp = explode(';',$line);
				$com = array_pop($tmp);
				$com = str_replace(array("\r\n","\r","\n"), '', $com);
				$popup[$key] = $com;
				$line = '$' . $key . " = " . $value . ";" . $com . "\n";
				$ex_line = $line_count - 1;
				while (preg_match('/^\/\/+/',$init_list[$ex_line])) {
					$memo = $init_list[$ex_line];
					$popup[$key] = $memo . $popup[$key];
					$ex_line--;
				}
				break;
			}
		}
		$new_init_list[] = $line;
		$line_count++;
	}
	file_put_contents('./init.php',$new_init_list,LOCK_EX);
	return 'init.phpの設定を復元しました';
}


function make_id() {
	global $id;
	$id = random_str(10);
	$init_list = file("./init.php");
	$new_init_list = array();
	foreach ($init_list as $line) {
		$tmp = $line;
		$tmp = str_replace(' ','',$tmp);
		$ptn = '/^\s?\$id ?= ?\'/';
		if (preg_match($ptn,$tmp)) {		
			$tmp = explode(';',$line);
			$com = array_pop($tmp);
			$new_id = '$id = ' . "'" . $id . "';" . $com;
			array_push($new_init_list,$new_id);
		} else {
			array_push($new_init_list,$line);
		}
	}
	file_put_contents('./init.php', $new_init_list, LOCK_EX);
	make_config();
}


function bbs($option = '') {
	global $img_ext,$bbs_help,$end,$script,$new_day,$datadir,$article,$indx,$indx2,$template,$article_template,$bbs_option, $t_title;
	global $title_, $writer_,$comment_,$date_,$id,$bbs_dir,$log,$id_path,$slide_lock,$show_dlc;
	global $tag_list,$hide_form,$inspect_mode,$error_abort,$cookietime,$alert,$ng_word, $form_expr,$hashed, $use_autolink, $show_text_file, $txt_ext, $block_ngip, $deny_proxy;
	$tmpl = $article_template;
	if (!is_dir($datadir)) { mkdir($datadir); }
	if (isset($_REQUEST['hide_form'])) {
		$hide_form = req('hide_form');
		setcookie("bbs_hide_form_" . article_id(), req('hide_form'), time() + 3600*24);
	} elseif (isset($_COOKIE['bbs_hide_form_' . article_id()])) {
		$hide_form = $_COOKIE['bbs_hide_form_' . article_id()];
	}
	if (req('res') || (req('id2') && req('bbs_pass'))) { $hide_form = 0; }
	if ($option) {
		$tmp = explode('|',$option);
		$option = array();
		foreach ($tmp as $_) {
			$tmp2 = explode('=',$_);
			$option[$tmp2[0]] = $tmp2[1];
		}
	} else {
		unset($option);
	}
	if (!isset($option['form'])) { $option['form'] = 'up'; }	// フォームの表示位置
	if (!isset($option['item'])) { $option['item'] = 'time'; }	// 記事の表示順
	//if (!isset($option['tag'])) { $option['tag'] = join(':',$perm_tag_list); }
	if (!isset($option['lock'])) { $option['lock'] = ''; }	// スライドロック表示
	if (!isset($option['nameless']) || !$option['nameless']) { $option['nameless'] = '名無し'; }	// 投稿者名未記入の場合
	if (!isset($option['titleless']) || !$option['titleless']) { $option['titleless'] = '無題'; }	// タイトル名未記入の場合
	if ($option['lock']) { $slide_lock = 1; } else { $slide_lock = 0; }
	$item = $option['item'];
	if (req('item')) { $item = req('item'); }
	if (!isset($option['max_log'])) { $option['max_log'] = 100; }	// ログの保存数
	if (!isset($option['max_past'])) { $option['max_past'] = 100; }	// 過去ログの最大数
	if (!isset($option['page_line'])) { $option['page_line'] = 10; }	// 1ページあたりの記事数
	$str = '';
	if (req('bbs_help')) {
		//$hash = array('id'=>$id,'bbs_help'=>0);
		$hash = array('bbs_help'=>0);
		if (req('noform')) { $hash['noform'] = req('noform'); }
		if (req('sort')) { $hash['sort'] = req('sort'); }
		if (req('item')) { $hash['item'] = req('item'); }
		$str .= "<a id=\"bbs_help\" href=\"" . script_link($hash,'bbs') . "\">戻る</a>";
		$str .= "<h1>bbs.phpのヘルプ</h1>\n";
		$bbs_help = preg_replace('/>\n+/',">\n",$bbs_help);
		$tmp = explode("\n",$bbs_help);
		foreach ($tmp as $_) {
			$mat = $trans = '';
			if (preg_match('/<dt>([^<]+)<\/dt>/',$_,$mat)) {
				if (isset($mat[1]) && isset($option[$mat[1]])) {
					$trans = " (現在の設定は" . $mat[1] . '=' . $option[$mat[1]] . ')';
				}
				$_ = preg_replace('/<dt>([^<]+)<\/dt>/',"<b>" . $mat[1] . "</b>" . $trans,$_);
			}
			if (!preg_match('/>$/',$_)) {
				$str .= $_ . "<br />\n";
			} else {
				$str .= $_ . "\n";
			}
		}
		$str = str_replace("\n","|n|",$str);
		$str = str_replace("!perm_tag!",join(',',$tag_list),$str);
		preg_match('/id="field"\s?style="([^"]+)"/',$template,$match);
		if (isset($match[1])) {
			$style = " style=\"" . $match[1] . "\"";
		} else {
			$style = '';
		}
		return "<div$style>$str</div>\n";
	}
	$id_dir = article_dir($id);
	if ($id_dir && !is_dir($id_dir)) { mkdir($id_dir); }
	$bbs_dir = join('/',array($id_dir,'bbs'));
	if (! is_dir($bbs_dir)) { mkdir($bbs_dir); }
	$id_path = join('/',array($id_dir,'bbs','bbs.cgi'));
	$log = array();
	$last = '';
	if (is_dir($id_dir) && file_exists($id_path)) {
		$log = file($id_path);
		$last = end($log);
		$last = rtrim($last);
	}
	if (req('show_past')) {
		$file_nmb = 1;
		while (file_exists(preg_replace('/\.cgi$/','_' . $file_nmb . '.cgi',$id_path))) {
			$file_nmb++;
		}
		if (req('past_nmb')) {
			$past_nmb = req('past_nmb');
		} else {
			$past_nmb = $file_nmb - 1;
		}
		$past_path = preg_replace('/\.cgi$/','_' . $past_nmb . '.cgi',$id_path);
		if (req('id2')) { $past_path = $bbs_dir . '/' . req('file'); }
		$log = file($past_path);
		$log = array_reverse($log);
		if ($item == 'thread') {
			$thread = array();
			foreach ($log as $line) {
				$tmp = explode('<>',$line);
				$line_[$tmp[0]] = $line;
				$ptitle = preg_replace('/^Re:/','',$tmp[2]);
				if (!isset($thread[$ptitle])) { $thread[$ptitle] = array(); }
				array_push($thread[$ptitle],$tmp[0]);
			}
			$new_log = array();
			foreach ($thread as $ptitle=>$val) {
				foreach ($val as $_) {
					$new_log[] = $line_[$_];
				}
			}
			$log = $new_log;
		}
		if (req('id2')) {
			$count = 0;
			foreach ($log as $line) {
				$tmp =explode('<>',$line);
				if ($tmp[0] == req('id2')) {
					$past_nmb = intval($count / $option['page_line']);
					break;
				}
				$count++;
			}
		}
		$hash = array('show_past'=>0);
		if (req('noform')) { $hash['noform'] = req('noform'); }
		if (req('sort')) { $hash['sort'] = req('sort'); }
		if (req('item')) { $hash['item'] = req('item'); }
		$indx = "<div style=\"padding-left:0.3em;\"><a href=\"" . script_link($hash) . "\">現行スレッド</a></div>\n<div style=\"padding-left:0.3em;\"><strong>過去ログ</strong></div>\n";
		$nmb = 1;
		$show_next_id = 0;
		for ($i=$file_nmb-1; $i>=1; $i--) {
			if ($i == $past_nmb) {
				$indx .= "<div style=\"padding-left:0.3em;\"><b>[$nmb]</b></div>\n";
			} else {
				$hash = array('id'=>$id,'past_nmb'=>$i,'show_past'=>1);
				if (req('noform')) { $hash['noform'] = req('noform'); }
				if (req('sort')) { $hash['sort'] = req('sort'); }
				if (req('item')) { $hash['item'] = req('item'); }
				//$link = script_link($hash) . "#next_page";
				$link = script_link($hash);
				if (!$show_next_id) {
					$indx .= "<div style=\"padding-left:0.3em;\"><a href=\"$link\" name=\"next_page\" id=\"next_page\">[" . $nmb . "]</a></div>\n";
					$show_next_id = 1;
				} else {
					$indx .= "<div style=\"padding-left:0.3em;\"><a href=\"$link\">[" . $nmb . "]</a></div>\n";
				}
			}
			$nmb++;
		}
		
		if ($item == 'time') {
			$hash = array('show_past'=>'1','item'=>'thread');
			if (req('noform')) { $hash['noform'] = req('noform'); }
			if (req('sort')) { $hash['sort'] = req('sort'); }
			if (req('past_nmb')) { $hash['past_nmb'] = req('past_nmb'); }
			$indx .= "<div style=\"padding-left:0.3em;\"><strong style=\"font-size:80%;\">投稿順に表示</strong></div>\n<div style=\"padding-left:0.3em;\"><a href=\"" . script_link($hash) . "\" style=\"font-size:80%;\">スレッドごとに表示</a></div>\n";
		} else {
			$hash = array('show_past'=>'1','item'=>'time');
			if (req('noform')) { $hash['noform'] = req('noform'); }
			if (req('sort')) { $hash['sort'] = req('sort'); }
			if (req('past_nmb')) { $hash['past_nmb'] = req('past_nmb'); }
			$indx .= "<div style=\"padding-left:0.3em;\"><a href=\"" . script_link($hash) . "\" style=\"font-size:80%;\">投稿順に表示</a></div>\n<div><strong style=\"font-size:80%;\">スレッドごとに表示</strong></div>\n";
		}
		$indx = "<div style=\"display:flex;flex-wrap:wrap; align-items:center;\">$indx</div>\n";
		$com = $last_title = '';
		foreach ($log as $line) {
			$tmpl = $article_template;
			$tmp = explode('<>',$line);
			list($idp,$datep,$titlep,$namep,$commentp,$hashed) = $tmp;
			if (isset($tmp[6])) { $rewrite = $tmp[6]; }
			$ptitle = preg_replace('/^Re(\[.+\])?:\s*/','',$titlep);
			if ($item == 'thread' && $last_title && $last_title == $ptitle) {
				$ptn = '/(class="article"[\s\S]*style=")(margin[^:]*[^;]+;)/';
				$com = preg_replace($ptn,'$1',$com);
			}
			$last_title = $ptitle;
			$tmpl = str_replace('!article_title!',$titlep,$tmpl);
			$tmpl = str_replace('!article_date!',$datep,$tmpl);
			$tmpl = str_replace('!article_writer!',$namep,$tmpl);
			$tmpl = str_replace('!article_id!',"bbs_" . $tmp[0],$tmpl);
			$tmpl = preg_replace('/<div[^>]*>!article_reply!<\/div>/','',$tmpl);
			//$tmpl = str_replace('!article_reply!','',$tmpl);
			$attach = $attach_str = '';
			$attach_mtime_list = array();
			$tmpdir = opendir($bbs_dir);
			while ($file = readdir($tmpdir)) {
				if (strpos($file,$idp) !== false && strpos($file,'oname') === false && strpos($file,'thumb') === false && strpos($file,'count') === false && strpos($file,'.cgi') === false) {
					$attach_mtime_list["$bbs_dir/$file"] = filemtime("$bbs_dir/$file");
					if (preg_match('/_(\d+)/', $file, $match)) {
						$nmb = $match[1];
						$attach_nmb[$nmb] = "$bbs_dir/$file";
					}
				}
			}
			closedir($tmpdir);
			$replace = array();
			for ($i=1;$i<=10;$i++) {
				if (strpos($commentp, "[file$i]") !== false) {
					if (isset($attach_nmb[$i])) {
						$replace[$i] = show_attach($attach_nmb[$i]);
						$commentp = str_replace('[file' . $i . ']', "[[replace$i]]", $commentp);
						unset($attach_mtime_list[$attach_nmb[$i]]);
					}
				}
			}
			if ($attach_mtime_list) {
				asort($attach_mtime_list);
				$attach_path_list = array_keys($attach_mtime_list);
				foreach ($attach_path_list as $path) {
					$attach_str .= show_attach($path);
				}
			}
			if ($attach_str) {
				$attach = "<div style=\"display: flex;flex-wrap:wrap;\">$attach_str</div>";
			}
			
			$tmpl = str_replace('!attach!',$attach,$tmpl);
			$commentp = str_replace('<','&lt;',$commentp);
			$commentp = str_replace('>','&gt;',$commentp);
			foreach ($replace as $key=>$val) {
				$commentp = str_replace("[[replace$key]]", $val, $commentp);
			}
			$commentp = preg_replace('/&lt;p&gt;/i','',$commentp);
			$commentp = str_replace("\t",str_repeat("&nbsp;",8),$commentp);
			$commentp = str_replace("    ",str_repeat("&nbsp;",4),$commentp);
			if (req('id2') == $tmp[0] && req('bbs_keyword')) {
				$commentp = keyword_coloring($commentp,req('bbs_keyword'),'background-color:#998822');
			}
			$com_line = preg_split('/&lt;br( \/)?&gt;/',$commentp);
			$tmp_list = array();
			foreach ($com_line as $line) {
				if (preg_match('/^(&gt;|>)/',$line)) {
					//$line = "<span style=\"border-radius:5px;padding:0.2em;background-color:#f0fafa;color:#444444;\">$line</span>";
					$line = "<span class=\"quote\">$line</span>";
				}
				$tmp_list[] = $line;
			}
			$commentp = join("<br />\n",$tmp_list);
			if ($use_autolink) { $commentp = autolink($commentp); }
			$tmpl = str_replace('!article!',$commentp,$tmpl);
			$com .= $tmpl;
		}
		$str .= $com;
		$indx2 = str_replace('name="next_page"','',$indx);
		$indx2 = str_replace('id="next_page"','',$indx2);
		$str .= $indx2;
		$str = str_replace("\n","|n|",$str);
		return $str;
	}
	if (req('bbs_admin') && !req('edit_template')) {
		return bbs_admin();
	} elseif (req('edit_spam')) {
		return bbs_admin();
		//return edit_spam();
	} elseif (req('edit_template')) {
		return bbs_admin();
		//return edit_template();
	} elseif (req('show_spam')) {
		$hash = array();
		$t_title .= "(スパム投稿)";
		if (req('noform')) { $hash['noform'] = req('noform'); }
		if (req('sort')) { $hash['sort'] = req('sort'); }
		if (req('item')) { $hash['item'] = req('item'); }
		if (isset($_COOKIE['bbs_admin_pass'])) {
			if ($_COOKIE['bbs_admin_pass']) {
				$hash['pass'] = $_COOKIE['bbs_admin_pass'];
				$hash['bbs_admin'] = 1;
			}
		}
		if (req('bbs_admin_login')) { $hash['bbs_admin_login'] = req('bbs_admin_login'); }
		$html = '';
		//$html .= "<div><a href=\"" . script_link($hash) . "\">戻る</a></div>\n";
		$html .= "<div style=\"text-align:center;\">ブロックされた投稿 !index!</div>";
		$spam_logs = array();
		$tmpdir = opendir($bbs_dir);
		while ($file=readdir($tmpdir)) {
			if (preg_match('/^bbs_spamlog_(\d+)\.cgi$/',$file,$match)) {
				$spam_logs[$match[1]] = $bbs_dir . '/' . $file;
			}
		}
		closedir($tmpdir);
		if (req('log') && file_exists(req('log'))) {
			$spam_log = file(req('log'));
		} else {
			if (file_exists($bbs_dir . '/' . 'bbs_spamlog.cgi')) { $spam_log = file($bbs_dir . '/' . 'bbs_spamlog.cgi'); }
			else { $spam_log = array(); }
		}
		if (count($spam_log) > 100) {
			array_shift($spam_log);
			file_put_contents($bbs_dir . '/' . 'bbs_spamlog.cgi',$spam_log,LOCK_EX);
		}
		$spam_log = array_reverse($spam_log);
		$count = 0;
		$label = '';
		$label .= "<div style=\"display:flex;flex-wrap:wrap;align-items:center;!back_color!\">\n";
		$label .= "<div style=\"flex-basis:11%;padding:0.2em;font-size:80%;\">時間</div>\n";
		$label .= "<div style=\"flex-basis:12%;padding:0.2em;\">タイトル</div>\n";
		$label .= "<div style=\"flex-basis:12%;padding:0.2em;\">投稿者</div>\n";
		//$label .= "</div>\n<div style=\"display:flex;flex-wrap:wrap;align-items:center;!back_color!\">\n";
		$label .= "<div style=\"flex-basis:50%;padding:0.2em;word-break:break-word;\">内容</div>\n";
		$label .= "<div style=\"flex-basis:12%;padding:0.2em;flex-grow:1;\">拒否</div>\n";
		$label .= "</div>\n";
		preg_match('/article_header" style="([^"]+)"/',$article_template,$match);
		if (isset($match[1])) { $style = $match[1]; } else { $style = 'background-color:teal;color:#fff;'; }
		$html .= str_replace('!back_color!',$style,$label);
		$show_spam = array();
		foreach ($spam_log as $line) {
			$tmp = explode('<>',$line);
			if ($tmp[0]) { $show_spam[] = $line; }
		}
		$spam_log = $show_spam;
		$comment_max_line = 5;
		foreach ($spam_log as $line) {
			$count++;
			if ($count % 2) { $back_color = "background-color:#ffffff;"; } else { $back_color = ''; }
			$tmp = explode('<>',$line);
			$tmp[1] = 1 * $tmp[1];
			if (preg_match('/^\d+$/',$tmp[6])) {
				$block = $tmp[6] . '秒';
			} elseif ($tmp[6]) {
				$block = $tmp[6];
			} else {
				$block = '投稿IDなし';
			}
			if (mb_strlen($tmp[4]) > 1000) {
				$comment = jtruncate($tmp[4],1000) . '...';
			} else {
				$comment = $tmp[4];
			}
			$tmp[2] = jtruncate($tmp[2],20);
			$tmp[3] = jtruncate($tmp[3],20);
			$comment = str_replace("<","&lt;",$comment);
			$comment = str_replace(">","&gt;",$comment);
			$comment = jtruncate($comment,200);
			$comment = str_replace("&lt;br /&gt;","<br />",$comment);
			$template = $label;
			$template = str_replace('!back_color!',$back_color,$template);
			$template = str_replace('時間',date("Y/m/d H:i:s", $tmp[1]),$template);
			$template = str_replace('タイトル',$tmp[2],$template);
			$template = str_replace('投稿者',$tmp[3],$template);
			$template = str_replace('内容',$comment,$template);
			$template = str_replace('拒否',$block,$template);
			$template = str_replace('IPアドレス',$tmp[7],$template);
			$template = str_replace('ホスト',$tmp[8],$template);
			$agent = user_agent($tmp[9]);
			if (is_array($agent)) { $agent = join(',',$agent); }
			$template = str_replace('エージェント',$agent,$template);
			$template = str_replace('HTTP_USER_AGENT',$tmp[9],$template);
			$html .= $template;
		}
		$index = '';
		if (count($spam_logs)) {
			$hash = array('show_spam'=>1,'bbs_admin_login'=>req('bbs_admin_login'));
			$link = script_link($hash);
			if (req('log')) {
				$index .= "[<a href=\"$link\">0</a>]";
			} else {
				$index .= "[<strong>0</strong>]";
			}
			arsort($spam_logs);
			$nmb = 1;
			foreach (array_keys($spam_logs) as $key) {
				if (req('log') == $spam_logs[$key]) {
					$index .= "[<strong>$nmb</strong>]";
				} else {
					$index .= "[<a href=\"$link&amp;log=" . $spam_logs[$key] . "\">$nmb</a>]";
				}
				$nmb++;
			}
		}
		$html = str_replace('!index!',$index,$html);
		return $html . "<div style=\"text-align:center;\">$index</div>\n";
	}
	if (req('bbs_keyword') && req('search')) {
		$hit_list = array();
		$hit_count = 0;
		$tmp_key = req('bbs_keyword');
		$tmp_key = str_replace('　',' ',$tmp_key);
		$tmp_key = preg_replace('/\s+/',' ',$tmp_key);
		$tmp_key = preg_replace('/^\s+/','',$tmp_key);
		$tmp_key = preg_replace('/\s+$/','',$tmp_key);
		$key_list = explode(' ',$tmp_key);
		$titles = $ids = $tms = array();
		$tmpdir = opendir($bbs_dir);
		while ($file = readdir($tmpdir)) {
			if (preg_match('/^bbs(_\d+)?\.cgi$/',$file)) {
				$log = file($bbs_dir . '/' . $file);
				$log = array_reverse($log);
				$line_nmb = 1;
				foreach ($log as $line) {
					$hit = 1;
					$tmp = explode('<>',$line);
					foreach ($key_list as $k) {
						//if (!preg_match('/(.{0,50})' . $k . '(.{0,60})/is',$line,$matched)) {
						if (!preg_match('/(.{0,80})(' . $k . ')(.{0,80})/is',$tmp[2] . "  " . $tmp[3] . "  " . $tmp[4],$matched)) {
						//if (!preg_match('/(.{0,50})' . $k . '(.{0,60})/is',$tmp[4],$matched)) {
							$hit = 0;
							break;
						}
					}
					if ($hit) {
						if (!isset($mat[$tmp[0]])) {
							if (isset($matched[3])) {
								$mat[$tmp[0]] = mb_substr($matched[1], -24, 24) . $matched[2] . mb_substr($matched[3], 0, 24);
							} else {
								$mat[$tmp[0]] = $matched[0];
							}
						}
						$file_[$tmp[0]] = $file;
						$line_nmb_[$tmp[0]] = $line_nmb;
						$titles[$tmp[0]] = $tmp[2];
						$tms[$tmp[0]] = $tmp[1];
						$hit_list[] = $tmp[0];
						$hit_count++;
					}
					$line_nmb++;
				}
			}
		}
		closedir($tmpdir);
		$titles_ =$titles;
		$sort = array_values($tms);
		arsort($tms);
		array_multisort($sort,SORT_DESC,SORT_STRING,$titles);
		$result = '';
		//foreach ($mat as $key=>$val) {
		foreach (array_keys($tms) as $key) {
			//if (!isset($mat[$key])) { continue; }
			$mat[$key] = str_replace('<','&lt;',$mat[$key]);
			$mat[$key] = str_replace('>','&gt;',$mat[$key]);
			$mat[$key] = keyword_coloring($mat[$key],req('bbs_keyword'),'color:crimson');
			$hash = array('noform'=>$id,'sort'=>req('sort'),'id2'=>$key,'bbs_keyword'=>req('bbs_keyword'));
			if (req('item')) { $hash['item'] = req('item'); }
			if ($file_[$key] != 'bbs.cgi') {
				$hash['show_past'] = 1;
				$hash['file'] = $file_[$key];
			}
			$result .= "<li><a href=\"" . script_link($hash) . "#bbs_$key" . "\">[" . $titles_[$key] . "]</a> <span style=\"font-size:80%;\">" . $tms[$key] . " " . $file_[$key] . " " . $line_nmb_[$key] . "</span><br /><span style=\"font-size:90%;\">" . $mat[$key] . "</span></li>\n";
		}
		if ($result) { $result = "<div style=\"padding:0.5em;background-color:#ffffff;\">\n<ul style=\"list-style:none;padding-left:0;\">$result</ul>\n</div>\n"; }
		$result = $hit_count . '件ヒット' . $result;
		list($form,$search_form) = form();
		$str .= $form . $result;
		return $result;
	}
	if (req('posted') || req('bbs_delete')) {
		if ($block_ngip && file_exists($bbs_dir . '/bbs_iplist.cgi')) {
			$ngip_list = file($bbs_dir . '/bbs_iplist.cgi', FILE_IGNORE_NEW_LINES);
		} else {
			$ngip_list = array();
		}
		$req = '';
		foreach ($_REQUEST as $key=>$val) { $req .= "$key → $val\n"; }
		$req .= "--------------------------------------------\n";
		if (!$id) {
			error('このフォームからは投稿できません');	// IDが特定されないフォームからの投稿は拒否
		} else {
			$post_id_file = $bbs_dir . '/' . req('post_id') . '.cgi';
			$remote_addr = $host = '';
			// スパムチェックをすべて行う
			if ($inspect_mode) {
				$spam_message['拒否IP'] = '投稿できません';
				$spam_message['ひらがな無し'] = 'コメントにひらがなが含まれていません';
				$spam_message['ダミー'] = '不正な投稿です';
				$spam_message['ID無し'] = '不正な投稿です';
				$spam_message['IDファイル無し'] = 'フォームを表示してから' . $form_expr . '分以内に投稿してください';
				$spam_message['slidelock無視'] = 'もう少し時間をおいてから投稿してください';
				$spam_message['タイトルにURL'] = 'タイトルにURLは使用しないでください';
				$spam_message['禁止用語'] = '禁止用語が含まれています';
				$spam_message['プロキシ'] = 'プロキシサーバー経由の投稿はご遠慮ください';
				$spam_flag = array();
				$remote_addr = $_SERVER['REMOTE_ADDR'];
				if (isset($_SERVER['REMOTE_HOST'])) { $host = $_SERVER['REMOTE_HOST']; }
				if (in_array($remote_addr, $ngip_list)) { $spam_flag[] = '拒否IP'; }
				if (!$host) { $host = gethostbyaddr($remote_addr); }
				if ($deny_proxy && preg_match('/^\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}$/', $host) && $host == $remote_addr) { $spam_flag[] = 'プロキシ'; }
				if (! preg_match('/[ぁ-ん]{2}/u', req('comment')) ) { $spam_flag[] = 'ひらがな無し'; }
				if (req('email')) { $spam_flag[] = 'ダミー'; }
				if (!req('post_id')) { $spam_flag[] = 'ID無し'; }
				if (!file_exists($post_id_file)) { $spam_flag[] = 'IDファイル無し'; }
				if (!req('rewrite') && !req('delete') && file_exists($post_id_file) && filemtime($post_id_file) + 8 > time()) {
					$spam_flag[] = (time() - filemtime($post_id_file)) . '秒';
				}
				if ($option['lock'] && !req('sliderInput') && !req('bbs_delete')) { $spam_flag[] = 'slidelock無視'; }
				if (preg_match('|https?://|',req('title'))) { $spam_flag[] = 'タイトルにURL'; }
				preg_match_all('|https?://[0-9a-z\-\./]+:?[0-9]*|',req('comment'),$url);
				if (count($url[0]) > 2) { $spam_flag[] = "URL" . count($url[0]) . '個'; }
				if ($ng_word && word_chk(req('comment'))) { $spam_flag[] = '禁止用語'; }
				if ($spam_flag) {
					spam_log(join("|",$spam_flag));
					$error_mes = array();
					foreach ($spam_flag as $flag) {
						if (isset($spam_message[$flag])) {
							$error_mes[] = $spam_message[$flag];
						} elseif (preg_match('/\d+秒$/',$flag)) {
							$error_mes[] = 'もう少し時間をおいてから投稿してください';
						} elseif (preg_match('/URL/',$flag)) {
							$error_mes[] = 'URLを減らしてください';
						} else {
							$error_mes[] = $flag;
						}
					}
					error(join("<br />",$error_mes));
				}
				if (file_exists($post_id_file)) {
					unlink($post_id_file);
				}
			// スパムチェックひとつでもひっかかると拒否処理
			} else {
				$remote_addr = $_SERVER['REMOTE_ADDR'];
				if (in_array($remote_addr, $ngip_list)) {
					spam_log('拒否IP');
					error('投稿できません');
				}
				if (isset($_SERVER['REMOTE_HOST'])) { $host = $_SERVER['REMOTE_HOST']; }
				if (!$host) { $host = gethostbyaddr($remote_addr); }
				if ($deny_proxy && preg_match('/^\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}$/', $host) && $host == $remote_addr) {
					spam_log('プロキシ');
					error('プロキシサーバー経由の投稿はご遠慮ください');
				}
				if (! preg_match('/[ぁ-ん]{2}/u', req('comment')) ) {
					spam_log('ひらがな無し');
					error('コメントにひらがなが含まれていません');
				}
				if (preg_match('|https?://|',req('title'))) {
					spam_log('タイトルにURL');
					error('タイトルにURLは使用しないでください');
				}
				preg_match_all('|https?://[0-9a-z\-\./]+:?[0-9]*|',req('comment'), $url);
				if (count($url[0]) > 2) {
					spam_log('URL多数');
					error('URLを減らしてください');
				}
				if (req('email')) {
					spam_log('ダミー');
					error('不正な投稿です');
				}
				if (!req('post_id')) {
					spam_log('ID無し');
					error('不正な投稿です' . $post_id_file . 'が存在しません');
				} elseif (!file_exists($post_id_file)) {
					spam_log('IDファイル無し');
					error('フォームを表示してから' . $form_expr . '分以内に投稿してください');
				} elseif (!req('rewrite') && !req('bbs_delete') && filemtime($post_id_file) + 8 > time()) {
					spam_log(time() - filemtime($post_id_file));
					error('もう少し時間をおいてから投稿してください');
				} elseif ($option['lock'] && !req('sliderInput')) {
					spam_log('slidelock無視');
					error('スライドロックを解除してください');
				} elseif ($ng_word && word_chk(req('comment'))) {
					spam_log('禁止用語');
					error('禁止用語が含まれています');
				} else {
					unlink($post_id_file);
				}
			}
			if (!is_dir($bbs_dir)) { mkdir($bbs_dir); }
			$obj = date_create('');
			$week_name = array('日','月','火','水','木','金','土');
			$w = date_format($obj, 'w');
			$tm = date_format($obj, 'Y年m月d日(曜日) H時i分');
			$tm = str_replace('曜日',$week_name[$w],$tm);
			$comment = req('comment');
			// 改行を削除
			$comment = str_replace("\r\n","\n",$comment);
			$comment = str_replace("\r","\n",$comment);
			$comment = str_replace("&","&amp;",$comment);
			$comment = tag_convert($comment);
			$comment = str_replace(">\n",">",$comment);
			$comment = str_replace("\n","<br />",$comment);
			$comment = str_replace("<>","&lt;&gt;",$comment);
			$title = req('title');
			if (req('writer')) {
				$writer = '<strong>' . strip_tags(req('writer')) . '</strong>';
			} else {
				$writer = '';
			}
			$tmp = explode('<>',$last);
			$id2 = $tmp[0];
			for ($i=0;$i<=4;$i++) {
				if (!isset($tmp[$i])) { $tmp[$i] = ''; }
			}
			if ($comment == $tmp[4] && $tm == $tmp[1]) {
				//$str .= "コメントが同じなので、キャンセル<br>";
			} else {
				if (preg_match('/^\s?$/',$comment)) {
					error('コメント内容がありません');
				}
				if (!$title || preg_match('/^' . $option['titleless'] . '\d*$/',$title)) {
					foreach ($log as $line) {
						$tmp = explode('<>',$line);
						if (preg_match('/^' . $option['titleless'] . '(\d*)?$/',$tmp[2],$mat)) {
							if ($mat[1] && is_numeric($mat[1])) {
								$title = $option['titleless'] . ($mat[1] + 1);
							} else {
								$title = $option['titleless'] . '1';
							}
						}
					}
					if (!$title) { $title = $option['titleless']; }
				}
				if (!$writer) {
					if ($option['nameless'] == 'id') {
						$writer = user_id();
					} else {
						$writer = $option['nameless'];
					}
				}
				
				// 再編集の場合
				if (req('rewrite') && req('hashed')) {
					$new_log = array();
					foreach ($log as $line) {
						$line = rtrim($line);
						if (strpos($line,'<>') == false) { continue; }
						$tmp = explode('<>',$line);
						if ($tmp[0] == req('id2') && $tmp[5] == req('hashed')) {
							$id2 = $tmp[0];
							if (req('bbs_delete')) {
								$tmpdir = opendir($bbs_dir);
								while ($file = readdir($tmpdir)) {
									if (preg_match('/^' . $id2 . '/',$file)) {
										unlink($bbs_dir . '/' . $file);
									}
								}
								closedir($tmpdir);
								continue;
							} else {
								$hashed = $tmp[5];
								$title = req('title');
								// パスワード欄が入力されていたらハッシュを再生成
								if (req('password')) {
									$hashed = password_hash(req('password'),PASSWORD_DEFAULT);
								}
								$line = join('<>',array($id2,$tm,$title,$writer,$comment,$hashed,'再編集'));
							}
						}
						$new_log[] = $line . "\n";
					}
					$error = upload($id2);
					if ($error_abort && $error) {
						error($error);
					} else {
						file_put_contents($id_path,$new_log,LOCK_EX);
					}
				
				// 新規登録の場合
				} else {
					if (req('password')) {
						$hashed = password_hash(req('password'),PASSWORD_DEFAULT);
					} else {
						$hashed = '';
					}
					$id2 = random_str(10);
					$id2 = req('post_id');		// post_idでいいかな？
					$error = upload($id2);
					if ($error_abort && $error) {
						error($error);
					} else {
						$line = join('<>',array($id2,$tm,$title,$writer,$comment,$hashed)) . "\n";
						file_put_contents($id_path,$line,FILE_APPEND | LOCK_EX);
					}
				}
			}
		}
	} elseif (req('del_file')) {
		foreach ($log as $line) {
			$tmp = explode('<>',$line);
			if (isset($tmp[5]) && $tmp[5]) { $hashed[$tmp[0]] = preg_replace('/\n$/','',$tmp[5]); }
		}
		$check = login(req('id2'), req('bbs_pass'), $hashed[req('id2')], $bbs_dir . '/login');
		if (!$check) {
			$del_file = $bbs_dir . '/' . req('del_file');
			if (file_exists($del_file)) { unlink($del_file); }
			$thumb_file = preg_replace('/(\..{2,4}$)/','thumb$1',$del_file);
			if (file_exists($thumb_file)) { unlink($thumb_file); }
			$oname_file = $del_file . '.oname';
			if (file_exists($oname_file)) { unlink($oname_file); }
		} else {
			error($check);
		}
	}
	$log = array();
	if (is_dir($bbs_dir) && file_exists($id_path)) {
		$log = file($id_path);
		if (count($log) > $option['max_log']) {
			$past_log = array_splice($log,0,(count($log) - $option['max_log']));
			$file_nmb = 1;
			$next_path = preg_replace('/\.cgi$/','_' . $file_nmb . '.cgi',$id_path);
			while (file_exists($next_path)) {
				$past_path = $next_path;
				$file_nmb++;
				$next_path = preg_replace('/\.cgi$/','_' . $file_nmb . '.cgi',$id_path);
			}
			if (!isset($past_path) || count(file($past_path)) >= $option['max_past']) { $past_path = $next_path; }
			file_put_contents($past_path,$past_log,FILE_APPEND | LOCK_EX);
			file_put_contents($id_path,$log,LOCK_EX);
		}
	}
	if ($log) {
		$log = array_reverse($log);	// 新しい順に表示するのに固定
		if ($item == 'thread') {
			$thread = array();
			foreach ($log as $line) {
				$tmp = explode('<>',$line);
				$line_[$tmp[0]] = $line;
				$ptitle = preg_replace('/^Re:/','',$tmp[2]);
				if (!isset($thread[$ptitle])) { $thread[$ptitle] = array(); }
				array_push($thread[$ptitle],$tmp[0]);
			}
			$new_log = array();
			foreach ($thread as $ptitle=>$val) {
				foreach ($val as $_) {
					$new_log[] = $line_[$_];
				}
			}
			$log = $new_log;
		}
		$line_nmb = 0;
		if (! req('page')) {
			$page = 0;
		} else {
			$page = req('page');
		}
		$end = intval((count($log) - 1)/$option['page_line']);
		if (req('id2')) {
			$count = 0;
			foreach ($log as $line) {
				$tmp =explode('<>',$line);
				if ($tmp[0] == req('id2')) {
					$page = intval($count / $option['page_line']);
					break;
				}
				$count++;
			}
		}
		$indx = '';
		if ($end > 0) {
			$show_next_id = 0;
			for ($i=0; $i<=$end; $i++) {
				if ($i == $page) {
					$indx .= "<div style=\"padding-left:0.3em;\"><b>[" . ($i+1) . "]</b></div>\n";
				} else {
					$hash = array('id'=>$id,'page'=>$i);
					if (req('noform')) { $hash['noform'] = req('noform'); }
					if (!req('noform')) { $hash['noform'] = $id; }
					if (req('sort')) { $hash['sort'] = req('sort'); }
					if (req('item')) { $hash['item'] = req('item'); }
					$link = script_link($hash);
					if (!$show_next_id) {
						$indx .= "<div style=\"padding-left:0.3em;\"><a href=\"$link\" name=\"next_page\" id=\"next_page\">[" . ($i+1) . "]</a></div>\n";
						$show_next_id = 1;
					} else {
						$indx .= "<div style=\"padding-left:0.3em;\"><a href=\"$link\">[" . ($i+1) . "]</a></div>\n";
					}
				}
			}
		}
		$past_path = preg_replace('/\.cgi$/','_1.cgi',$id_path);
		if (file_exists($past_path)) {
			$hash = array('id'=>$id,'show_past'=>1);
			if (req('noform')) { $hash['noform'] = req('noform'); }
			if (req('sort')) { $hash['sort'] = req('sort'); }
			if (req('item')) { $hash['item'] = req('item'); }
			$indx .= "<div style=\"padding-left:0.3em;\"><a href=\"" . script_link($hash) . "\" style=\"white-space:nowrap;\">過去ログ</a></div>\n";
		}
		if ($end) {
			if ($item == 'time') {
				$hash = array('id'=>$id,'item'=>'thread');
				if (req('noform')) { $hash['noform'] = req('noform'); }
				if (req('sort')) { $hash['sort'] = req('sort'); }
				if (req('page')) { $hash['page'] = req('page'); }
				$indx .= "<div style=\"padding-left:0.3em;\"><strong style=\"font-size:80%;\">投稿順に表示</strong></div><div style=\"padding-left:0.3em;\"><a href=\"" . script_link($hash) . "\" style=\"font-size:80%;\">スレッドごとに表示</a></div>\n";
			} else {
				$hash = array('id'=>$id,'item'=>'time');
				if (req('noform')) { $hash['noform'] = req('noform'); }
				if (req('sort')) { $hash['sort'] = req('sort'); }
				if (req('page')) { $hash['page'] = req('page'); }
				$indx .= "<div style=\"padding-left:0.3em;\"><a href=\"" . script_link($hash) . "\" style=\"font-size:80%;\">投稿順に表示</a></div><div style=\"padding-left:0.3em;\"><strong style=\"font-size:80%;\">スレッドごとに表示</strong></div>\n";
			}
		}
		$indx = "<div style=\"display:flex;flex-wrap:wrap; align-items:center;\">$indx</div>\n";
		$last_title = $back_color = '';
		$hashed = array();
		foreach ($log as $line) {
			$tmpl = $article_template;
			if ($line_nmb < $page * $option['page_line'] || $line_nmb >= ($page + 1) * $option['page_line']) {
				$line_nmb++;
				continue;
			}
			$tmp = explode('<>',$line);
			$id2 = $tmp[0];
			if (isset($tmp[5])) { $tmp[5] = rtrim($tmp[5]); }
			for ($i=0;$i<=4;$i++) {
				if (!isset($tmp[$i])) { $tmp[$i] = ''; }
			}
			$hash = array('reedit'=>1,'id'=>$id,'id2'=>$id2);
			if (req('sort')) { $hash['sort'] = req('sort'); }
			if (req('page')) { $hash['page'] = req('page'); }
			if (req('item')) { $hash['item'] = req('item'); }
			$edit_link = script_link($hash);
			$ptitle = preg_replace('/^Re:/','',$tmp[2]);
			if ($item == 'thread' && $last_title && $last_title == $ptitle) {
				$ptn = '/(<div class="article".*?style=".*)(margin[^:]*[^;]+;)([^"]*?"[\s]*id="' . $last_id . '")/';
				$str = preg_replace($ptn,'$1' . '$3',$str);
			}
			$last_title = $ptitle;
			$new = '';
			$date_str = $tmp[1];
			$date_str = preg_replace('/(\d+)年(\d+)月(\d+)日\(.+\)/','$1-$2-$3',$date_str);
			$date_str = preg_replace('/(\d+)時(\d+)分/','$1:$2',$date_str);
			if (strtotime($date_str) + 3600*24*$new_day > time()) {
				$new = "<span class=\"new_color\" style=\"font-size:80%;padding:0 0.2em;\">new!</span> ";
			}
			$tmpl = str_replace('!article_title!',"$new" . $tmp[2],$tmpl);
			$tmpl = str_replace('!article_date!',$tmp[1],$tmpl);
			$tmpl = str_replace('!article_writer!',$tmp[3],$tmpl);
			$tmpl = str_replace('!article_id!',"bbs_" . $id2,$tmpl);
			$last_id = "bbs_" . $id2;
			$article[$tmp[0]]['article_title'] = "$new<strong>" . $tmp[2] . "</strong>";
			$article[$tmp[0]]['article_date'] = $tmp[1];
			$article[$tmp[0]]['article_writer'] = $tmp[3];
			$hash = array('id'=>$id,'id2'=>$id2,'res'=>1);
			if (req('noform')) {
				$hash['noform'] = req('noform');
			} elseif ($id) {
				$hash['noform'] = $id;
			}
			if (req('sort')) { $hash['sort'] = req('sort'); }
			if (req('page')) { $hash['page'] = req('page'); }
			if (req('item')) { $hash['item'] = req('item'); }
			$res_link = script_link($hash);
			$reply = "<a href=\"$res_link\">返信</a>";
			$article[$tmp[0]]['article_reply'] = "<a href=\"$res_link\">返信</a>";
			if ($tmp[5]) {
				$reply .= "&nbsp;&nbsp;<a href=\"$edit_link#bbs_$id2\">編集</a>\n";
				$article[$tmp[0]]['article_reply'] .= "&nbsp;&nbsp;<a href=\"$edit_link#bbs_$id2\">編集</a>\n";
			}
			$mod_link = '';
			//if (req('hashed') && req('hashed') == $tmp[5] && !req('bbs_pass') && !req('posted')) {
			if (req('reedit') && req('id2') && req('id2') == $tmp[0] && !req('bbs_pass') && !req('posted') && !req('res')) {
				$hash = array('hashed'=>req('hashed'),'id2'=>$id2);
				if (req('noform')) { $hash['noform'] = req('noform'); }
				if (req('sort')) { $hash['sort'] = req('sort'); }
				if (req('page')) { $hash['page'] = req('page'); }
				$mod_link .= script_form_file($hash,'bbs');
				$cookie_chk = $cwpass = '';
				if (isset($_COOKIE['bbs_writer_use_cookie']) && $_COOKIE['bbs_writer_use_cookie']) {
					$cookie_chk = ' checked="checked"';
					if (isset($_COOKIE['bbs_writer_pass'])) { $cwpass = $_COOKIE['bbs_writer_pass']; }
				}
				$mod_link .= "<div style=\"display:flex;flex-wrap:wrap;align-items:center;\">\n\t<div style=\"padding:0.2em;\"><span style=\"font-size:80%;\">編集パスワードを入力してください</span></div>\n";
				if ($cwpass) {
					$mod_link .= "\t<div style=\"padding:0.2em;\"><input type=\"password\" name=\"bbs_pass\" value=\"$cwpass\" style=\"width:140px;\" /></div>\n";
				} else {
					$mod_link .= "\t<div style=\"padding:0.2em;\"><input type=\"text\" name=\"bbs_pass\" value=\"\" style=\"width:140px;\" /></div>\n";
				}
				$mod_link .= "\t<div style=\"padding:0.2em;\"><input id=\"bbs\" type=\"submit\" value=\"編集\" /></div>\n";
				$mod_link .= "\t<div style=\"padding:0.2em;\"><input$cookie_chk id=\"chk_box\" type=\"checkbox\" name=\"use_cookie\" value=\"1\" /><label for=\"chk_box\"><span style=\"font-size:80%;\">パスワードをクッキーに保存</span></label></div>\n";
				$mod_link .= "</div>\n</form>\n";
			} elseif (req('id2') && req('id2') == $tmp[0] && req('bbs_pass')) {
				$check = login(req('id2'), req('bbs_pass'), $tmp[5], $bbs_dir . '/login');
				if (!$check) {
					if (req('use_cookie')) {
						setcookie("bbs_writer_pass", req('bbs_pass'), time() + $cookietime * 3600 * 24);
						setcookie("bbs_writer_use_cookie", 1, time() + $cookietime * 3600 * 24);
					} else {
						setcookie("bbs_writer_pass", '', time() - 30);
						setcookie("bbs_writer_use_cookie", '', time() - 30);
					}
				} else {
					error($check);
					if ($tmp[5]) { $mod_link .= "&nbsp;<span style=\"font-weight:bold;color:#00ffff;\">$check</span>"; }
					$alert = $check;
				}
			}
			$reply .= "$mod_link";
			$tmpl = str_replace('!article_reply!',$reply,$tmpl);
			$article[$tmp[0]]['article_reply'] .= "$mod_link";
			if (req('id2') == $tmp[0] && req('bbs_keyword')) { $tmp[4] = keyword_coloring($tmp[4],req('bbs_keyword'),'background-color:#998822'); }
			$tmp[4] = str_replace("\t",str_repeat("&nbsp;",8),$tmp[4]);
			$tmp[4] = str_replace("    ",str_repeat("&nbsp;",4),$tmp[4]);
			$tmp[4] = show_tag($tmp[4]);
			$tmp2 = explode('<br />',$tmp[4]);
			$tmp_list = array();
			foreach ($tmp2 as $line) {
				if (preg_match('/^(&gt;|>)/',$line)) { $line = "<span class=\"quote\">$line</span>"; }
				$tmp_list[] = $line;
			}
			//$tmpl = str_replace('!article!',join('<br />',$tmp_list),$tmpl);
			if ($use_autolink) {
				$tmpl = str_replace('!article!',join('<br />',autolink($tmp_list)),$tmpl);
			} else {
				$tmpl = str_replace('!article!',join('<br />',$tmp_list),$tmpl);
			}
			$article[$tmp[0]]['article'] = join('<br />',$tmp_list);
			
			$attach_str = '';
			$attach_path_list = $attach_mtime_list = array();
			$tmpdir = opendir($bbs_dir);
			while ($file = readdir($tmpdir)) {
				if (preg_match('/^' . $id2 . '/',$file) && strpos($file,'oname') === false && strpos($file,'thumb') === false && strpos($file,'count') === false) {
					$attach_mtime_list["$bbs_dir/$file"] = filemtime("$bbs_dir/$file");
					if (preg_match('/_(\d+)/', $file, $match)) {
						$nmb = $match[1];
						$attach_nmb[$nmb] = "$bbs_dir/$file";
					}
				}
			}
			closedir($tmpdir);
			for ($i=1;$i<=10;$i++) {
				if (strpos($tmpl, "[file$i]") !== false) {
					if (isset($attach_nmb[$i])) {
						$tmpl = str_replace('[file' . $i . ']', show_attach($attach_nmb[$i]), $tmpl);
						unset($attach_mtime_list[$attach_nmb[$i]]);
					}
				}
			}
			if ($attach_mtime_list) {
				asort($attach_mtime_list);
				$attach_path_list = array_keys($attach_mtime_list);
				foreach ($attach_path_list as $path) {
					$attach_str .= show_attach($path);
				}
			}
			if ($attach_str) { $attach_str = "\n<div style=\"display: flex;flex-wrap:wrap;\">\n$attach_str</div>\n"; }
			$tmpl = str_replace('!attach!',$attach_str,$tmpl);
			$article[$tmp[0]]['attach'] = $attach_str;
			$hashed[$tmp[0]] = $tmp[5];
			$comment_[$tmp[5]] = $tmp[4];
			$title_[$tmp[5]] = $tmp[2];
			$writer_[$tmp[5]] = $tmp[3];
			$date_[$tmp[5]] = $tmp[1];
			$line_nmb++;
			$str .= $tmpl;
		}
		$indx2 = str_replace('name="next_page"','',$indx);
		$indx2 = str_replace('id="next_page"','',$indx2);
		$str .= $indx2;
	}
	$str = str_replace("\n","|n|",$str);
	return $str;
}


function show_attach($path) {
	global $img_ext, $show_dlc, $show_text_file, $txt_ext;
	$ext = pathinfo($path,PATHINFO_EXTENSION);
	$attach_str = '';
	if (preg_grep('/' . $ext . '/i',$img_ext)) {
	//if (in_array($ext,$img_ext)) {
		list($image_w, $image_h) = getimagesize($path);
		$width = 500;
		$proportion = $image_w / $image_h;
		$height = $width / $proportion;
		//高さが幅より大きい場合は、高さを幅に合わせ、横幅を縮小
		if($proportion < 1){
			$height = $width;
			$width = $width * $proportion;
			$width = intval($width * 0.8);
			$height = intval($height * 0.8);
		}
		if ($width > $image_w) { $width = $image_w; }
		if (file_exists($path . '.oname')) {
			$title_name = file_get_contents($path . '.oname');
		} else {
			$title_name = basename($path);
		}
		$dl = '';
		if (file_exists($path . '.count')) {
			$dl = " title=\"" . filesize($path . '.count') . "dl\"";
		}
		$attach_str .= "<div style=\"padding:3px;\"><img src=\"$path\" width=\"$width\" alt=\"" . basename($path) . "\" title=\"" . $title_name . "\" onclick=\"cmanImgPop(this,'')\" /></div>\n";
	} else {
		$oname = $path . '.oname';
		$org = $path;
		if (file_exists($oname)) { list($org) = file($oname); }
		$sjis_org = mb_convert_encoding($org,'SJIS','UTF-8');
		$hash = array('mode'=>'download', 'file'=>$path, 'name'=>urlencode($sjis_org));
		$link = script_link($hash);
		$dl = '';
		if ($show_dlc && file_exists($path . '.count')) {
			$dl = "&nbsp;" . filesize($path . '.count') . 'dl';
		}
		$o_ext = $ext;
		if (file_exists($path . '.oname')) {
			$o_name = file_get_contents($path . '.oname', FILE_IGNORE_NEW_LINES);
			preg_match('/\.(.{3,4}$)/', $o_name, $match);
			if (isset($match[1])) {
				$o_ext = $match[1];
			}
		}
		if ($show_text_file && preg_grep('/' . $o_ext . '/i',$txt_ext)) {
			$txt_str = "<div><pre>!<$path>!</pre></div>\n";
		} else {
			$txt_str = '';
		}
		$attach_str .= "<div style=\"padding:3px;\"><div><a href=\"$link\"><img src=\"./img/clip.gif\" alt=\"$org\" />$org</a>  $dl</div>$txt_str</div>\n";
	}
	return($attach_str);
}


function word_chk($str) {
	global $ng_word;
	$ng_word_list = explode(',',$ng_word);
	$hit = 0;
	foreach ($ng_word_list as $word) {
		if (preg_match('/' . $word . '/',$str)) {
			$hit = 1;
			break;
		}
	}
	return $hit;
}


function upload($id2) {
	global $bbs_dir, $upload_error;
	$upload_error = $uploaded = 0;
	if ($_FILES['upfile']["error"] == UPLOAD_ERR_OK) {
		$tmp_name = $_FILES['upfile']["tmp_name"];
		$t_name = $_FILES['upfile']["name"];	// とりあえず元のファイル名から拡張子を取るだけ
		$ext = pathinfo($t_name, PATHINFO_EXTENSION);
		if ($ext == 'php' || $ext == 'cgi') {
			$ext = 'txt';	// 拡張子がphpやcgiの場合はtxtに変更
		}
		if (! is_dir($bbs_dir)) { mkdir($bbs_dir); }
		//$up_path = $bbs_dir . '/' . $id2 . '.' . $ext;
		$up_path = '';
		$tmp_list = array();
		$tmpdir = opendir($bbs_dir);
		while ($file = readdir($tmpdir)) {
			if (preg_match('/^' . $id2 . '/', $file)) {
				$tmp_list[] = $file;
			}
		}
		closedir($tmpdir);
		$tmp_list_str = join('', $tmp_list);
		for ($i=1;$i<=10;$i++) {
			if (strpos($tmp_list_str, $id2 . "_$i") === false) {
				$up_path = $bbs_dir . '/' . $id2 . "_$i" . '.' . $ext;
				break;
			}
		}
		if ($up_path) {
			$uploaded = file_upload('upfile', $up_path);
		}
		if (!$uploaded) { return($upload_error); }
//		if (file_exists($up_path)) {
//			$del_file = 1;
//			for ($i=1;$i<=5;$i++) {
//				$tmp_path = $bbs_dir . '/' . $id2 . "_$i" . '.' . $ext;
//				if (!file_exists($tmp_path)) {
//					$up_path = $tmp_path;
//					$del_file = 0;
//					break;
//				}
//			}
//			if ($del_file) { unlink($up_path); }
//		}
//		$uploaded = file_upload('upfile', $up_path);
//		if (!$uploaded) { return($upload_error); }
	}
}



// ファイルをアップロードして画像ファイルの場合はサムネールを作成する
function file_upload($upname, $uppath) {
	global $allow_ext, $upload_error, $upload_max_size, $img_ext, $thumb_width;
	$mt_list = array('jpg'=>'image/jpeg','jpeg'=>'image/jpeg','png'=>'image/png','pdf'=>'application/pdf','zip'=>'application/zip','gif'=>'image/gif','psd'=>'image/vnd.adobe.photoshop',);
	$mt_list['txt'] = 'text/(x-perl|plain)';
	$mt_list['docx'] = 'application/vnd.openxmlformats-officedocument.wordprocessingml.document';
	$mt_list['doc'] = 'application/msword';
	$mt_list['xlsx'] = 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet';
	$mt_list['zip'] = 'application/zip';
	$mt_list['wav'] = 'audio/x-wav';
	$mt_list['tga'] = 'image/x-tga';
	$mt_list['cgi'] = 'text/(x-perl|plain)';
	$mt_list['ai'] = 'application/pdf';
	$mt_list['php'] = 'text/(x-php|plain)';
	$mt_list['wmv'] = 'video/x-ms-asf';
	$mt_list['bmp'] = '(image/x-ms-bmp|application/octet-stream)';
	$mt_list['eps'] = array('application/postscript','image/x-eps');
	$mt_list['csv'] = 'text/plain';
	$mt_list['html'] = 'text/html';
	$mt_list['xls'] = 'application/vnd.ms-excel';
	
	$mn_list = array('jpg'=>'FFD8FFE','jpeg'=>'FFD8DDE0','png'=>'89504E47','pdf'=>'255044462D312E3','zip'=>'504b03040a0000000000','gif'=>'47494638(37|39)61','psd'=>'38425053','docx'=>'504b0304140006000800','xlsx'=>'504b0304140006000800');
	$mn_list['mp4'] = '000000206674797069736F6D00000200';
	$mn_list['txt'] = '[0-9a-fA-F]{10}';
	$mn_list['doc'] = 'd0cf11e0a1b11ae';
	$mn_list['zip'] = '504b0304';
	$mn_list['wav'] = '524946462a';
	$mn_list['tga'] = '00000';
	$mn_list['cgi'] = '(23212f7573722f6c6f63616c2|[0-9a-fA-F]{10})';
	$mn_list['ai'] = '255044462d312e3';
	$mn_list['php'] = '3c3f706870';
	$mn_list['wmv'] = '3026b2758e66cf11a6d900aa0062ce6c';
	$mn_list['bmp'] = '424d';
	$mn_list['eps'] = array('252150532d41646f62652d332e3020455053462d332e300a25','c5d0d3c6');
	$mn_list['csv'] = '[0-9a-fA-F]{10}';
	$mn_list['html'] = '[0-9a-fA-F]{10}';
	$mn_list['xls'] = 'd0cf11e0a1b11ae';
	if (!$upname || $upname == 'mime_check') { return(array($mt_list,$mn_list)); }
	$alart = '';
	if (isset($_FILES[$upname]) && $_FILES[$upname]["error"] == UPLOAD_ERR_OK) {
		$tmp_path = $_FILES[$upname]["tmp_name"];
		$updir = dirname($uppath);
		if (! is_dir($updir)) { mkdir($updir); }
		$baename = basename($tmp_path);
		$finfo = new finfo();
		$mime_type = $finfo->file( $tmp_path, FILEINFO_MIME_TYPE);
		$original_name = $_FILES[$upname]["name"];	// とりあえず元のファイル名から拡張子を取るだけ
		$ext = strtolower(pathinfo($original_name, PATHINFO_EXTENSION));
		$upload_error = '';
		if ($_FILES[$upname]['size'] >= $upload_max_size*1024*1024) {
			$upload_error .= "<div>ファイルサイズが" . intval($_FILES[$upname]['size']/1024/1024) . "MBありました。アップロードできるのは{$upload_max_size}MBまでです</div>\n";
		}
		$tmp_file_data = bin2hex(file_get_contents($tmp_path));
		if (!in_array($ext,$allow_ext)) {
			$alart = 0;
			$upload_error .= "<div>" . $ext . "ファイルはアップロードできません</div>\n";
			$upload_error .= "<div>アップロードできるファイルは<b>" . join(' ',$allow_ext) . "</b>です</div>\n";
		}
		if ($upload_error) { return $alart; }
		if (!isset($mt_list[$ext]) || !isset($mn_list[$ext])) {
			$alart = 0;
			$upload_error = "アップロードに失敗しました(mimeタイプが未設定です)";
		} else {
			if (!is_array($mt_list[$ext])) {
				if (!preg_match('~^' . $mt_list[$ext] . '$~i',$mime_type)) {
					$alart = 0;
					$upload_error = "アップロードに失敗しました(" . $mt_list[$ext] . '<>' . $mime_type . ")";
				} else {
					$alart = 1;
				}
			} else {
				$alart = 0;
				foreach ($mt_list[$ext] as $mt) {
					if (preg_match('~^' . $mt . '$~i',$mime_type)) {
						$alart = 1;
						break;
					}
				}
			}
			if ($alart) {
				if (!is_array($mn_list[$ext])) {
					if (!preg_match('/^' . $mn_list[$ext] . '/i',substr($tmp_file_data,0,50))) {
						$alart = 0;
						$upload_error = "アップロードに失敗しました(" . $mn_list[$ext] . '<>' . substr($tmp_file_data,0,50) . ")";
					} else {
						$alart = 1;
					}
				} else {
					$alart = 0;
					foreach ($mn_list[$ext] as $mn) {
						if (preg_match('/^' . $mn . '/i',substr($tmp_file_data,0,50))) {
							$alart = 1;
							break;
						}
					}
				}
			}
			if (!$alart && !$upload_error) {
				$upload_error = "アップロードに失敗しました";
			}
		}
		if ($alart) {
			move_uploaded_file($tmp_path, $uppath);
			// 画像ファイルの場合サムネールを作成
			if (in_array($ext,$img_ext)) { thumb($uppath, $thumb_width); }
			$onfile = $uppath . '.oname';
			file_put_contents($onfile,$original_name,LOCK_EX);
			$upload_error = "{$original_name}をアップロードしました";
			$alart .= "<div>{$original_name}をアップロードしました</div>\n";
		}
	}
	return $alart;
}


function req($key) {
	return isset($_REQUEST[$key]) ? $_REQUEST[$key] : '';
}


function random_str($length = '') {
	if (! $length) { $length = 10 ; }
	$salt = array_merge(range('a', 'z'), range('0', '9'), range('A', 'Z'));
	$login_id = '';
	for ($i = 0; $i < $length; $i++) {
		$login_id .= $salt[rand(0, count($salt)-1)];
	}
	return $login_id;
}



function keyword_coloring($string,$keys) {
	$keys = str_replace('　',' ',$keys);
	$keys = preg_replace('/\s+/',' ',$keys);
	$keys = preg_replace('/\s$/','',$keys);
	$keys = preg_replace('/^\s+/','',$keys);
	$key_list = explode(' ',$keys);
	foreach ($key_list as $key) {
		//$string = str_ireplace($key, "<span class=\"keyword\">$key</span>", $string);	// 置換後、大文字小文字が変わってしまう
		$string = preg_replace('/(' . $key . ')/i', "<span class=\"keyword\">$1</span>", $string);
	}
	return $string;
}




function bbs_admin() {
	global $bbs_dir, $str, $log, $id_path, $id, $id_path, $img_ext, $bbs_option, $expr, $script, $t_title;
	
	$mes = '';
	if (! file_exists($bbs_dir)) { mkdir($bbs_dir); }
	if (! file_exists($bbs_dir. '/login')) { mkdir($bbs_dir. '/login'); }
	$login_dir = $bbs_dir. '/login';
	$tmpdir = opendir($bbs_dir);
	$file_list = array();
	while ($file = readdir($tmpdir)) {
		if (!preg_match('/^\.{1,2}$/',$file)) {
			$file_list[] = $file;
		}
	}
	closedir($tmpdir);
	$tmpdir = opendir($login_dir);
	while ($file = readdir($tmpdir)) {
		if (!preg_match('/bruteforce_attack\.cgi$/',$file) && preg_match('/^\w{10}_/',$file) && filemtime($login_dir . '/' . $file) + 60 * $expr < time()) {
			unlink($login_dir . '/' . $file);
		}
	}
	closedir($tmpdir);
	$hash = array();
	foreach (array_keys($_REQUEST) as $key) {
		if (preg_match('/^bbs_admin/',$key)) { continue; }
		if (preg_match('/^(comment_|mod_|del_|pass)/',$key)) { continue; }
		$hash[$key] = req($key);
	}
	$file_nmb = 1;
	while (file_exists(preg_replace('/\.cgi$/','_' . $file_nmb . '.cgi',$id_path))) {
		$file_nmb++;
	}
	if (req('past_nmb')) {
		$past_nmb = req('past_nmb');
	}
	if (isset($past_nmb)) {
		$past_path = preg_replace('/\.cgi$/','_' . $past_nmb . '.cgi',$id_path);
		$id_path = $past_path;
		$log = file($past_path);
		//$log = array_reverse($log);
	}
	if (!req('bbs_admin_login')) {
		if (! req('pass')) {
			$hash = array();
			foreach (array_keys($_REQUEST) as $key) {
				$hash[$key] = req($key);
			}
			$str .= "<div>\n" . script_form($hash,'bbs');
			$cpass = $cookie_chk = '';
			if (isset($_COOKIE['bbs_admin_pass'])) { $cpass = $_COOKIE['bbs_admin_pass']; }
			if (isset($_COOKIE['bbs_admin_use_cookie']) && $_COOKIE['bbs_admin_use_cookie']) { $cookie_chk = ' checked'; }
			$str .= "<div style=\"display:flex;flex-wrap:wrap;align-items:center;\">";
			$str .= "<div style=\"padding:0.2em;\"><input type=\"password\" name=\"pass\" value=\"$cpass\" size=\"12\"></div>\n";
			$str .= "<div style=\"padding:0.2em;\"><input type=\"submit\" name=\"login\" value=\"ログイン\"></div>\n";
			$str .= "<div style=\"padding:0.2em;\"><input id=\"chkbox\"$cookie_chk type=\"checkbox\" name=\"bbs_admin_use_cookie\" value=\"1\"><label for=\"chkbox\"><span style=\"font-size:80%;\">パスワードをクッキーに保存する</span></label></div>\n";
			$str .= "</div>\n";
			$str .= "</form>\n</div>\n";
			return $str;
		} else {
			global $crypt_pass, $cookietime;
			$check = login('admin', req('pass'), $crypt_pass, $login_dir);
			if ($check) {
				error($check);
			} else {
				$bbs_admin_login = random_str(10);
				$hash['bbs_admin_login'] = $bbs_admin_login;
				file_put_contents(join('/',array($login_dir, $bbs_admin_login . '_' . $_SERVER['SERVER_NAME'] . '.cgi')),'',LOCK_EX);
				if (req('bbs_admin_use_cookie')) {
					setcookie("bbs_admin_pass", req('pass'), time() + $cookietime * 3600 * 24);
					setcookie("bbs_admin_use_cookie", 1, time() + $cookietime * 3600 * 24);
					setcookie("bbs_cpass", req('pass'), time() + 3600*24);		// アクセス権限を管理者レベルにするためのクッキー
				} else {
					setcookie("bbs_admin_use_cookie", '', time() - 30);
					setcookie("bbs_admin_pass", '', time() - 30);
				}
			}
			$hash['pass'] = '';
		}
	} else {
		$login_path = join('/',array($login_dir, req('bbs_admin_login') . '_' . $_SERVER['SERVER_NAME'] . '.cgi'));
		$lhash = array('noform'=>req('noform'),'sort'=>req('sort'),'bbs_admin'=>1);
		$relogin = script_link($lhash,'bbs');
		if (! file_exists($login_path) ) {
			error("時間切れです。再度ログインしてください。&nbsp;<a href=\"$relogin\">ログイン</a>");
		} else {
			if (filemtime($login_path) + 60 * $expr < time()) {
				unlink($login_path);
				error("時間切れです。再度ログインしてください。&nbsp;<a href=\"$relogin\">ログイン</a>");
			} else {
				file_put_contents($login_path,'',LOCK_EX);
			}
		}
	}
	// index_base.htmlと./template/index_base.htmlの内容が違っていたら
	if (!isset($bbs_admin_login)) { $bbs_admin_login = req('bbs_admin_login'); }
	$chk_template = chk_template($bbs_admin_login);
	if ($chk_template) {
		return($chk_template);
	}
	
	if (req('bbs_config')) { 
		$t_title .= "(設定)";
		return bbs_config();
	}
	if (req('edit_spam')) {
		$t_title .= "(スパム投稿管理)";
		return edit_spam();
	} elseif (req('edit_ip')) {
		$t_title .= "(拒否IPアドレス管理)";
		return edit_ip();
	}
	if (req('edit_template')) { return edit_template(); }
	if (req('past_nmb')) {
		$t_title .= "(過去ログ管理)";
	} else {
		$t_title .= "(ログ管理)";
	}
	foreach (array_keys($_REQUEST) as $key) {
		if (preg_match('/^del_(\w+$)/',$key,$match)) {
			$del_id = $match[1];
			$new_log = array();
			foreach ($log as $line) {
				$tmp = explode('<>',$line);
				if ($tmp[0] != $del_id) {
					$new_log[] = $line;
				} else {
					$mes .= '<div><strong>[' . $tmp[2] . ']</strong> の記事を削除しました。</div>';
				}
			}
			$log = $new_log;
			file_put_contents($id_path,$log,LOCK_EX);
			$del_files = preg_grep('/^' . $del_id . '/',$file_list);
			foreach ($del_files as $file) {
				if (unlink("$bbs_dir/$file")) {
					$mes .= '<div><strong>' . "$bbs_dir/$file" . '</strong> を削除しました。</div>';
				}
			}
			break;
		} elseif (preg_match('/^mod_(\w+$)/',$key,$match)) {
			$mod_id = $match[1];
			$new_log = array();
			foreach ($log as $line) {
				$tmp = explode('<>',$line);
				if ($tmp[0] == $mod_id) {
					$tmp[4] = req('comment_' . $mod_id);
					$tmp[4] = str_replace("&","&amp;",$tmp[4]);
					$tmp[4] = tag_convert($tmp[4]);
					$tmp[4] = str_replace("\r\n","\n",$tmp[4]);
					$tmp[4] = str_replace("\r","\n",$tmp[4]);
					$tmp[4] = str_replace(">\n",">",$tmp[4]);
					$tmp[4] = str_replace("\n",'<br />',$tmp[4]);
					$line = join('<>',$tmp);
					$mes .= '<strong>[' . $tmp[2] . ']</strong> の記事を修正しました。';
				}
				$new_log[] = $line;
			}
			$log = $new_log;
			file_put_contents($id_path,$log,LOCK_EX);
		}
	}
	$str .= "<a href=\"" . script_link($hash,'bbs') . "\">戻る</a>";
	$hash['bbs_admin'] = 1;
	if (req('bbs_admin_login') || (isset($bbs_admin_login) && $bbs_admin_login)) {
		if (req('bbs_admin_login')) {
			$hash['bbs_admin_login'] = req('bbs_admin_login');
		} elseif ($bbs_admin_login) {
			$hash['bbs_admin_login'] = $bbs_admin_login;
		}
		$str .= "&nbsp;&nbsp;<a href=\"" . script_link($hash,'bbs') . "\">再読み込み</a>";
	}
	$hash = array('bbs_admin'=>1,'bbs_config'=>1);
	if (req('noform')) { $hash['noform'] = req('noform'); }
	if (req('sort')) { $hash['sort'] = req('sort'); }
	if (req('item')) { $hash['item'] = req('item'); }
	if (isset($bbs_admin_login) && $bbs_admin_login) { $hash['bbs_admin_login'] = $bbs_admin_login; }
	if (req('bbs_admin_login')) { $hash['bbs_admin_login'] = req('bbs_admin_login'); }
	$str .= " <a href=\"" . script_link($hash) . "\">掲示板の設定</a>";
	if (file_exists($bbs_dir . '/' . 'bbs_spamlog.cgi') && filesize($bbs_dir . '/' . 'bbs_spamlog.cgi') > 0) {
		$hash = array('edit_spam'=>1);
		if (req('noform')) { $hash['noform'] = req('noform'); }
		if (req('sort')) { $hash['sort'] = req('sort'); }
		if (req('item')) { $hash['item'] = req('item'); }
		if (isset($bbs_admin_login) && $bbs_admin_login) { $hash['bbs_admin_login'] = $bbs_admin_login; }
		if (req('bbs_admin_login')) { $hash['bbs_admin_login'] = req('bbs_admin_login'); }
		$str .= "&nbsp;&nbsp;<a href=\"" . script_link($hash) . "#bbs_block\">拒否投稿</a>";
	}
	if (file_exists($login_dir . '/bruteforce_attack.cgi')) {
		$str .= "  <a href=\"$script?mode=show_bruteforce_log\" target=\"_blank\">ブルートフォースログ</a>\n";
	}
	$indx = '';
	if ($log) {
		$hash_i = array('past_nmb'=>'','bbs_admin'=>req('bbs_admin'));
		if (req('noform')) { $hash_i['noform'] = req('noform'); }
		if (req('sort')) { $hash_i['sort'] = req('sort'); }
		if (req('item')) { $hash_i['item'] = req('item'); }
		if (isset($bbs_admin_login) && $bbs_admin_login) { $hash_i['bbs_admin_login'] = $bbs_admin_login; } elseif (req('bbs_admin_login')) {
			$hash_i['bbs_admin_login'] = req('bbs_admin_login');
		}
		if (isset($past_nmb)) {
			$link = script_link($hash_i);
			$indx .= "<div style=\"padding:0.1em;\"><a href=\"$link\">現行ログ</a></div>\n";
		} else {
			$indx .= "<div style=\"padding:0.1em;\"><b>現行ログ</b></div>\n";
		}
		$past = 0;
		if (file_exists(preg_replace('/\.cgi$/','_1.cgi',$id_path))) { $past = 1; }
		if (isset($past_nmb) && $past_nmb) {
			$indx .= "<div style=\"padding:0.1em;\">　<b>過去ログ</b></div>\n";
		} elseif ($past) {
			$indx .= "<div style=\"padding:0.1em;\">　過去ログ</div>\n";
		}
		$nmb = 1;
		$show_next_id = 0;
		for ($i=$file_nmb-1; $i>=1; $i--) {
			if (isset($past_nmb) && $i == $past_nmb) {
				$indx .= "<div style=\"padding:0.1em;\"><b>[$nmb]</b></div>\n";
			} else {
				$hash_i['past_nmb'] = $i;
				$link = script_link($hash_i);
				if (!$show_next_id) {
					$indx .= "<div style=\"padding:0.1em;\"><a href=\"$link\" name=\"next_page\" id=\"next_page\">[" . $nmb . "]</a></div>\n";
					$show_next_id = 1;
				} else {
					$indx .= "<div style=\"padding:0.1em;\"><a href=\"$link\">[" . $nmb . "]</a></div>\n";
				}
			}
			$nmb++;
		}
		$str .= "<div style=\"display:flex;flex-wrap:wrap;\">$indx<div style=\"padding:0.1em;margin-left:auto;\">ログ数:" . count($log) . "</div>\n</div>";
	}
	$str .= "<div style=\"color:crimson\">$mes</div>\n";
	$hash = array();
	$hash['show_spam'] = 0;
	$hash['edit_spam'] = 0;
	$hash['bbs_admin'] = 1;
	$hash['pass'] = req('pass');
	if (req('past_nmb')) { $hash['past_nmb'] = req('past_nmb'); }
	if (isset($bbs_admin_login) && $bbs_admin_login) {
		$hash['bbs_admin_login'] = $bbs_admin_login;
	} elseif (req('bbs_admin_login')) {
		$hash['bbs_admin_login'] = req('bbs_admin_login');
	}
	$str .= script_form($hash);
	$str .= "<div>\n";
	$hash['bbs_admin'] = 1;
	$count = 0;
	foreach (array_reverse($log) as $line) {
		$count++;
		$tmp = explode('<>',$line);
		$aid = $tmp[0];
		$attach = preg_grep('/^' . $aid . '/',$file_list);
		$comment = $tmp[4];
		$comment = str_replace('<br />',"\n",$comment);
		if ($count % 2) {
			$backcol = "background-color:#ffffff;";
		} else {
			$backcol = "";
		}
		$str .= "<div style=\"display:flex;flex-wrap:wrap;align-items:flex-start;padding:0.2em;$backcol\">";
		$str .= "<div style=\"padding:0.2em;\"><textarea name=\"comment_" . $tmp[0] . "\" cols=\"40\" rows=\"2\" style=\"width:100%;\">" . $comment . "</textarea></div>";
		$str .= "<div style=\"padding:0.2em;\"><input type=\"submit\" name=\"mod_" . $tmp[0] . "\" value=\"修正\" style=\"font-size:80%;\"></div>";
		$hash['del_' . $tmp[0]] = 1;
		$str .= "<div style=\"padding:0.2em;\"><input type=\"submit\" name=\"del_" . $tmp[0] . "\" value=\"削除\" style=\"font-size:80%;\"></div>";
		$atc_str = '';
		foreach ($attach as $atc) {
			if (preg_match('/thumb\./',$atc) || preg_match('/\.(oname|count)$/',$atc)) { continue; }
			$oname_file = $atc . '.oname';
			if (in_array($oname_file,$file_list)) {
				$oname_path = "$bbs_dir/" . $oname_file;
				$oname = file_get_contents($oname_path,);
				$oname_str = " alt=\"$oname\" title=\"$oname\"";
			} else {
				$oname_str = $oname = '';
			}
			$ext = pathinfo($atc,PATHINFO_EXTENSION);
			if (preg_grep('/' . $ext . '/i',$img_ext) && !preg_match('/thumb\./',$atc)) {
				$thumb_file = preg_replace('/(\..{2,4}$)/','thumb$1',$atc);
				$thumb_path = "$bbs_dir/" . $thumb_file;
				$o_path = str_replace('thumb', '', $thumb_path);
				if (in_array($thumb_file,$file_list)) {
					$atc_str .= "<div style=\"padding:0.1em;\"><img src=\"$thumb_path\"$oname_str onclick=\"cmanImgPop(this, '$o_path')\" /></div>\n";
				} else {
					$atc_str .= "<div style=\"padding:0.1em;\"><img src=\"$bbs_dir/$atc\"$oname_str onclick=\"cmanImgPop(this, '$o_path')\" /></div>\n";
				}
			} else {
				$atc_str .= "<div style=\"padding:0.1em;\"><img src=\"./img/clip.gif\"$oname_str /></div>\n";
			}
		}
		$str .= "<div style=\"display:flex;\">$atc_str</div>";
		$str .= "<div style=\"display:flex;flex-wrap:wrap; margin-left:auto;\"><div style=\"padding:0.2em;\">" . $tmp[2] . "</div><div style=\"padding:0.2em;\">" . $tmp[3] . "</div><div style=\"font-size:80%;padding:0.2em;\">" . $tmp[1] . "</div></div>\n";
		unset($hash['del_' . $tmp[0]]);
		$str .= "</div>\n";
	}
	$str .= "</div>\n";
	$str .= "</form>\n";
	$str = str_replace("\n","|n|",$str);
	return $str;
}


function edit_ip() {
	global $script,$bbs_dir, $article_template, $ng_word, $deny_ngip, $htac_dir;
	$hash = array();
	if (req('noform')) { $hash['noform'] = req('noform'); }
	if (req('sort')) { $hash['sort'] = req('sort'); }
	if (req('item')) { $hash['item'] = req('item'); }
	if (req('bbs_admin_login')) { 
		$hash['bbs_admin_login'] = req('bbs_admin_login');
		$hash['bbs_admin'] = 1;
	}
	$html = '';
	$html .= "<div><a href=\"" . script_link($hash) . "\">戻る</a></div>\n";
	$block_ip_path = $bbs_dir . '/' . 'bbs_iplist.cgi';
	if (req('post')) {
		if (!isset($htac_dir) || !$htac_dir) { $htac_dir = '.'; }	// .htaccessを置くディレクトリ
		$block = array();
		foreach ($_REQUEST as $key=>$val) {
			if ($val && preg_match('/^\d{1,3}_\d{1,3}_\d{1,3}_\d{1,3}$/', $key)) {
				$block[] = str_replace('_', '.', $key);
			}
		}
		file_put_contents($block_ip_path, join("\n", $block), LOCK_EX);
		if ($deny_ngip) {
			$old_hta = '';
			if (file_exists($htac_dir . '/' . '.htaccess')) {
				$old_hta = file_get_contents($htac_dir . '/' . '.htaccess');
				$ptn = '/(#bbs\.php[\s\S]*#\/bbs.php\s?)/';
				$old_hta = preg_replace($ptn, '', $old_hta);
			}
			if ($old_hta) { $old_hta = rtrim($old_hta) . "\n"; }
			$htac_str = $old_hta . "#bbs.php IPアドレス拒否\norder allow,deny\nallow from all\n";
			foreach ($block as $ip) {
				$htac_str .= "deny from $ip\n";
			}
			$htac_str .= "#/bbs.php\n";
			file_put_contents($htac_dir . '/' . '.htaccess', $htac_str, LOCK_EX);
		} else {
			if (file_exists($htac_dir . '/' . '.htaccess')) {
				$htac = file_get_contents($htac_dir . '/' . '.htaccess');
				$ptn = '/(#bbs\.php[\s\S]*#\/bbs.php\s?)/';
				$htac = preg_replace($ptn, '', $htac);
				if (!$htac || preg_match('/^\s+$/', $htac)) {
					unlink($htac_dir . '/' . '.htaccess');
				} else {
					file_put_contents($htac_dir . '/' . '.htaccess', $htac, LOCK_EX);
				}
			}
		}
	}
	if (file_exists($block_ip_path)) {
		$block_ip_list = file($block_ip_path, FILE_IGNORE_NEW_LINES);
	} else {
		$block_ip_list = array();
	}
	foreach ($block_ip_list as $ip) {
		$block_ip[$ip] = 1;
	}
	$spam_logs = array($bbs_dir . '/' . 'bbs_spamlog.cgi');
	$tmpdir = opendir($bbs_dir);
	while ($file=readdir($tmpdir)) {
		if (preg_match('/^bbs_spamlog_(\d+)\.cgi$/',$file,$match)) {
			$spam_logs[$match[1]] = $bbs_dir . '/' . $file;
		}
	}
	closedir($tmpdir);
	$spam_data = array();
	foreach ($spam_logs as $path) {
		$spam_data = array_merge($spam_data, file($path, FILE_IGNORE_NEW_LINES));
	}
	$count = array();
	foreach ($spam_data as $line) {
		$tmp = explode('<>', $line);
		if (isset($tmp[7])) {
			if (!isset($count[$tmp[7]])) { $count[$tmp[7]] = 0; }
			$count[$tmp[7]]++;
			$log_dat[$tmp[7]][] = $line;
		}
	}
	if ($count) {
	arsort($count);
	$html .= "<form action=\"$script\" method=\"post\">\n";
	$hash = array('pass'=>req('pass'), 'bbs_admin'=>req('bbs_admin'), 'bbs_admin_login'=>req('bbs_admin_login'), 'edit_ip'=>1);
	$html .= script_form($hash);
	$html .= "<input type=\"submit\" name=\"post\" value=\"チェックしたIPアドレスを拒否リストに追加する\">";
	$html .= "<div id=\"index_0\" style=\"display:flex;flex-wrap:wrap;align-items:center;\"><div style=\"flex-basis:1em;\">　</div><div style=\"flex-basis:10em;text-align:center;\">IPアドレス</div><div style=\"flex-basis:3em;text-align:center;\"><span style=\"font-size:80%;\">投稿数</span></div><div></div></div>\n";
	$nmb = 0;
	foreach ($count as $key=>$val) {
		$nmb++;
		if ($nmb % 2) {
			$back = "background-color:#fff;";
		} else {
			$back = "";
		}
		if (req('show_spam') == $key) {
			$hash['show_spam'] = '';
			$show_spam_link = "<a href=\"" . script_link($hash) . "#index_$key\">ログを隠す</a>";
		} else {
			$hash['show_spam'] = $key;
			$show_spam_link = "<a href=\"" . script_link($hash) . "#index_$key\">ログ確認</a>";
		}
		if (isset($block_ip[$key]) && $block_ip[$key]) {
			$html .= "<div id=\"index_$key\" style=\"{$back}display:flex;flex-wrap:wrap;\"><div style=\"bflex-basis:1em;\"><input checked type=\"checkbox\" id=\"$key\" name=\"$key\" value=\"1\"></div><div style=\"flex-basis:10em;\"><label for=\"$key\" style=\"font-weight:bold;\">$key</label></div><div style=\"flex-basis:3em;text-align:center;\">($val)</div><div>$show_spam_link</div></div>\n";
		} else {
			$html .= "<div id=\"index_$key\" style=\"{$back}display:flex;flex-wrap:wrap;\"><div style=\"flex-basis:1em;\"><input type=\"checkbox\" id=\"$key\" name=\"$key\" value=\"1\"></div><div style=\"flex-basis:10em;\"><label for=\"$key\">$key</label></div><div style=\"flex-basis:3em;text-align:center;\">($val)</div><div>$show_spam_link</div></div>\n";
		}
		if (req('show_spam') && req('show_spam') == $key) {
			foreach ($log_dat[req('show_spam')] as $line) {
				$html .= "<div>$line</div>";
			}
		}
	}
	$html .= "</form>\n";
	}
	return($html);
}


function edit_spam() {
	global $script,$bbs_dir, $article_template, $ng_word;
	$hash = array();
	if (req('noform')) { $hash['noform'] = req('noform'); }
	if (req('sort')) { $hash['sort'] = req('sort'); }
	if (req('item')) { $hash['item'] = req('item'); }
	if (req('bbs_admin_login')) {
		$hash['bbs_admin_login'] = req('bbs_admin_login');
		$hash['bbs_admin'] = 1;
	}
	$html = '';
	$html .= "<div><a href=\"" . script_link($hash) . "\">戻る</a></div>\n";
	$hash['edit_ip'] = 1;
	$html .= "<div style=\"text-align:center;\">ブロックした投稿 !index!   <a href=\"" . script_link($hash) . "\">拒否IPアドレスリスト</a></div>";
	$spam_logs = array();
	$tmpdir = opendir($bbs_dir);
	while ($file=readdir($tmpdir)) {
		if (preg_match('/^bbs_spamlog_(\d+)\.cgi$/',$file,$match)) {
			$spam_logs[$match[1]] = $bbs_dir . '/' . $file;
		}
	}
	closedir($tmpdir);
	if (req('log') && file_exists(req('log'))) {
		$spam_path = req('log');
	} else {
		$spam_path = $bbs_dir . '/' . 'bbs_spamlog.cgi';
	}
	$spam_log = file($spam_path);
	$logmtime = filemtime($spam_path);
	if (count($spam_log) > 100) {
		array_shift($spam_log);
		file_put_contents($bbs_dir . '/' . 'bbs_spamlog.cgi',$spam_log,LOCK_EX);
	}
	$spam_log = array_reverse($spam_log);
	$count = $bc_count = 0;
	$label = '';
	$label .= "<div style=\"display:flex;flex-wrap:wrap;align-items:center;!back_color!\">\n";
	$label .= "<div style=\"flex-basis:4em;padding:0.2em;font-size:80%;white-space:nowrap;\">表示</div>\n";
	$label .= "<div style=\"flex-basis:6em;padding:0.2em;font-size:80%;\">時間</div>\n";
	$label .= "<div style=\"flex-basis:10em;padding:0.2em;\">タイトル</div>\n";
	$label .= "<div style=\"flex-basis:7em;padding:0.2em;\">投稿者</div>\n";
	$label .= "<div style=\"flex-basis:40em;padding:0.2em;\">内容</div>\n";
	$label .= "<div style=\"flex-basis:10em;padding:0.2em;\">拒否</div>\n";
	$label .= "<div style=\"flex-basis:6em;padding:0.2em;\">IPアドレス</div>\n";
	$label .= "<div style=\"flex-basis:6em;padding:0.2em;\">ホスト</div>\n";
	$label .= "<div style=\"flex-basis:6em;padding:0.2em;\"><a title=\"HTTP_USER_AGENT\">エージェント</a></div>\n";
	$label .= "<div style=\"flex-basis:3em;padding:0.2em;text-align:right;\">削除</div>";
	$label .= "</div>\n";
	preg_match('/article_header" style="([^"]+)"/',$article_template,$match);
	if (isset($match[1])) { $style = $match[1]; } else { $style = 'background-color:teal;color:#fff;'; }
	$html .= str_replace('!back_color!',$style,$label);
	$new_log = array();
	foreach ($spam_log as $line) {
		$count++;
		if (req('delete' . $count)) {
			continue;
		}
		$tmp = explode('<>',$line);
		$tmp[1] = 1 * $tmp[1];
		if (req('delete' . $tmp[1])) { continue; }
		$bc_count++;
		if ($bc_count % 2) { $back_color = "background-color:#ffffff;"; } else { $back_color = ''; }
		if (preg_match('/^\d+$/',$tmp[6])) {
			$block = $tmp[6] . '秒';
		} elseif ($tmp[6]) {
			$block = $tmp[6];
		} else {
			$block = '投稿IDなし';
		}
		if (mb_strlen($tmp[4]) > 1000) {
			$comment = jtruncate($tmp[4],1000) . '...';
		} else {
			$comment = $tmp[4];
		}
		$comment = str_replace("<","&lt;",$comment);
		$comment = str_replace(">","&gt;",$comment);
		$comment = str_replace("&lt;br /&gt;","<br />",$comment);
		if ($ng_word) {
			$ng_list = explode(',', $ng_word);
		} else {
			$ng_list= array();
		}
		$ng_hit = array();
		$comment_plus = '';
		$style_list = array('color:crimson;', 'color:blue;', 'color:deeppink;', 'color:purple;', 'color:brown;', 'color:navy;',  'color:green;', 'color:peru;', 'color:darkgreen;');
		$ng_count = 0;
		foreach ($ng_list as $ngw) {
			if (preg_match('/' . $ngw . '/', $comment)) {
				$comment = preg_replace('/(' . $ngw . ')/','<span style="' . $style_list[$ng_count % count($style_list)] . '">' . '$1' . '</span>', $comment);
				$ng_hit[] = '<span style="' . $style_list[$ng_count % count($style_list)] . '">' . $ngw . '</span>';
			}
			$ng_count++;
		}
		$comment .= $comment_plus;
		if ($ng_hit) { $comment .= "<hr /><div>" . join('&lt;&gt;', $ng_hit) . "</div>\n<hr />\n"; }
		$template = $label;
		$hash = array('edit_spam'=>1,'bbs_admin_login'=>req('bbs_admin_login'),'log'=>req('log'));
		//if (req('show' . $count)) {
		if (req('show' . $tmp[1])) {
			$tmp[0] = 1;
			$line = join('<>',$tmp);
		//} elseif (req('show' . $count) == '0') {
		} elseif (req('show' . $tmp[1]) == '0') {
			$tmp[0] = '';
			$line = join('<>',$tmp);
		}
		if ($tmp[0]) {
			$hash['show' . $tmp[1]] = 0;
			$hash['edit'] = 1;
			$show_link = "<a id=\"spam$count\" href=\"" . script_link($hash) . "#spam$count\">表示</a>";
		} else {
			$hash['show' . $tmp[1]] = 1;
			$hash['edit'] = 1;
			$show_link = "<a id=\"spam$count\" href=\"" . script_link($hash) . "#spam$count\">非表示</a>";
			$back_color = "background-color:#bbbbbb;color:#666666;";
		}
		$hash = array('edit_spam'=>1,'bbs_admin_login'=>req('bbs_admin_login'),'log'=>req('log'), 'delete' . $tmp[1]=>1, 'edit'=>1);
		$del_link = "<a id=\"spam$count\" href=\"" . script_link($hash) . "#spam$count\">削除</a>";
		$template = str_replace('!back_color!',$back_color,$template);
		$template = str_replace('表示',$count . ' ' . $show_link,$template);
		$template = str_replace('削除', $del_link, $template);
		$date = date("Y/m/d H:i:s", $tmp[1]);
		$date = str_replace(' ', '<br />', $date);
		$template = str_replace('時間',$date,$template);
		$template = str_replace('タイトル',$tmp[2],$template);
		$template = str_replace('投稿者',$tmp[3],$template);
		$template = str_replace('内容',$comment,$template);
		$template = str_replace('拒否',$block,$template);
		$template = str_replace('IPアドレス',$tmp[7],$template);
		$template = str_replace('ホスト',$tmp[8],$template);
		$agent = user_agent($tmp[9]);
		if (is_array($agent)) { $agent = join(',',$agent); }
		$template = str_replace('エージェント',$agent,$template);
		$template = str_replace('HTTP_USER_AGENT',$tmp[9],$template);
		$html .= $template;
		$new_log[] = $line;
	}
	if (req('edit')) {
		file_put_contents($spam_path,array_reverse($new_log),LOCK_EX);
		// 表示非表示を変更してもスパムログファイルの更新時間は変更しない
		if (isset($logmtime) && $logmtime) { touch($spam_path,$logmtime); }
	}
	$index = '';
	if (count($spam_logs)) {
		$hash = array('edit_spam'=>1,'bbs_admin_login'=>req('bbs_admin_login'));
		$link = script_link($hash);
		if (req('log')) {
			$index .= "[<a href=\"$link\">0</a>]";
		} else {
			$index .= "[<strong>0</strong>]";
		}
		arsort($spam_logs);
		$nmb = 1;
		foreach (array_keys($spam_logs) as $key) {
			if (req('log') == $spam_logs[$key]) {
				$index .= "[<strong>$nmb</strong>]";
			} else {
				$index .= "[<a href=\"$link&amp;log=" . $spam_logs[$key] . "\">$nmb</a>]";
			}
			$nmb++;
		}
	}
	$html = str_replace('!index!',$index,$html . "<div style=\"text-align:center;\">$index</div>\n");
	return $html;

}


function chk_template($bbs_admin_login) {
	global $script;
	$template = file_get_contents('./index_base.html', FILE_IGNORE_NEW_LINES);
	if (!file_exists('./template/index_base.html')) {
		if (!is_dir('./template')) { mkdir('./template'); }
		copy('./index_base.html', './template/index_base.html');
		return;
	}
	$backup = file_get_contents('./template/index_base.html', FILE_IGNORE_NEW_LINES);
	if ($template == $backup) { return; }
	$hash = array('bbs_admin'=>1,'bbs_admin_login'=>$bbs_admin_login);
	$html = "<div><a href =\"" . script_link($hash) . "\">戻る</a></div>\n";
	if (req('select_template')) {
		if (req('template') == './index_base.html') {
			$i = 1;
			while (file_exists('./template/index_base'. $i . '.html')) { $i++; }
			rename('./template/index_base.html','./template/index_base' . $i . '.html');
			copy('./index_base.html', './template/index_base.html');
			$html .= "<div>./template/index_base.htmlを更新しました</div>\n";
		} elseif (req('template') == './template/index_base.html') {
			$i = 1;
			while (file_exists('./template/index_base'. $i . '.html')) { $i++; }
			rename('./index_base.html','./template/index_base' . $i . '.html');
			copy('./template/index_base.html', './index_base.html');
			$html .= "<div>./index_base.htmlを更新しました</div>\n";
		}
		return($html);
	}
	$html .= "<div>./index_base.htmlと./template/index_base.htmlの内容が違います。どちらをテンプレートとして使用しますか</div>\n";
	$hash['chk_template'] = 1;
	$hash['select_template'] = 1;
	$html .= "<div style=\"display:flex;flex-wrap:wrap;\"><div style=\"flex-basis:18em;\"><a href=\"" . script_link($hash) . "&amp;template=./index_base.html\">./index_base.htmlを使用</div><div><a href=\"$script?preview_template=1&amp;template=./index_base.html\" target=\"_blank\">プレビュー</a></div></div>\n";
	$html .= "<div style=\"display:flex;flex-wrap:wrap;\"><div style=\"flex-basis:18em;\"><a href=\"" . script_link($hash) . "&amp;template=./template/index_base.html\">./template/index_base.htmlを使用</div><div><a href=\"$script?preview_template=1&amp;template=./template/index_base.html\" target=\"_blank\">プレビュー</a></div></div>\n";
	return($html);
}

function preview_template() {
	//global $html, $template, $article_template, $field_template, $item, $max_log, $max_past, $page_line, $lock, $titleless, $nameless;
	global $t_title;
	if (file_exists(req('template'))) {
		$template = file_get_contents(req('template'), FILE_IGNORE_NEW_LINES);
		$template = str_replace('</body>', req('template') . 'のプレビュー</body>', $template);
		$html = $template;
		if (isset($add_header_link) && $add_header_link) {
			$html = $template = str_replace('!add_header_link!',$add_header_link,$html);
		} else {
			$html = $template = str_replace('!add_header_link!','',$html);
		}
		$t_title .= '(' . req('template') . "のプレビュー)";
		print print_html($html);
	}
}


function edit_template() {
	global $script;
	$message = '';
	if (req('overwrite')) {
		$path = req('template_file');
		$path = urlencode($path);
		$path = str_replace("%2F", "/", $path);
		file_put_contents($path, req('html'), LOCK_EX);
	} elseif (req('saveas') && req('save_to')) {
		if (req('new_name')) {
			$path = req('new_name');
			if (!preg_match('/^\.\/template/', $path)) {
				$path = './template/' . $path;
				if (!preg_match('/\.html$/', $path)) {
					$path .= '.html';
				}
			}
		} else {
			$path = req('save_to');
		}
		$path = urlencode($path);
		$path = str_replace("%2F", "/", $path);
		file_put_contents($path, req('html'), LOCK_EX);
	} elseif (req('delete') && req('save_to')) {
		if (preg_match('/index_base\.html/', req('save_to'))) {
			error(req('save_to') . "は削除できません");
		}
		$path = req('save_to');
		$path = urlencode($path);
		$path = str_replace("%2F", "/", $path);
		if (file_exists($path)) {
			if (unlink($path)) {
				$message = "{$path}を削除しました。";
			} else {
				$message = "{$path}を削除できませんでした。";
			}
		}
	} 
	if (req('preview') && req('html')) {
		$template = req('html');
	} elseif (!req('delete') && req('template_file')) {
		$path = urlencode(req('template_file'));
		$path = str_replace("%2F", "/", $path);
		$template = file_get_contents($path);
	} else {
		$template = file_get_contents('./index_base.html');
	}
	$hash = array('bbs_admin'=>1,'bbs_admin_login'=>req('bbs_admin_login'), 'bbs_config'=>1);
	$html = '';
	$html .= "<div style=\"padding:2em 6em;background-color:#fff;\">\n"; 
	$html .= "<div><a href=\"" . script_link($hash) . "\">戻る</a></div>\n";
	$tmpl_list = array();
	$tmpl_list[] = 'index_base.html';
	if (!file_exists('./template/index_base.html') || filemtime('./index_base.html') != filemtime('./template/index_base.html')) {
		copy('./index_base.html', './template/index_base.html');
	}
	$tmpdir = opendir('./template');
	while ($file = readdir($tmpdir)) {
		if (preg_match('/\.html$/', $file)) {
			$tmpl_list[] = './template/' . $file;
		}
	}
	closedir($tmpdir);
	$html .= "<form action=\"$script\" method=\"post\">\n";
	$hash['bbs_config'] = '';
	$hash['edit_template'] = 1;
	if (req('template_file')) {
		$hash['template_file'] = req('template_file');
	} else {
		$hash['template_file'] = './index_base.html';
	}
	foreach ($hash as $key=>$val) {
		$html .= "<input type=\"hidden\" name=\"$key\" value=\"$val\" />\n";
	}
	$html .= "<div style=\"display:flex;flex-wrap:wrap;\">\n<div style=\"padding:0.5em;\"><input type=\"submit\" name=\"preview\" value=\"プレビュー\" /></div>\n<div style=\"padding:0.5em;\"><input type=\"submit\" name=\"reset\" value=\"リセット\">$message</div>\n</div>\n";
	$save_to = "<div><input type=\"text\" name=\"new_name\" value=\"\"></div>\n";
	$save_to .= "<div><select name=\"save_to\" size=\"" . (count($tmpl_list) - 1). "\">";
	$list = "<div>\n";
	$req['template_file'] = req('template_file');
	if (!$req['template_file'] || req('reset')) { $req['template_file'] = 'index_base.html'; }
	$req['save_to'] = req('save_to');
	if (!$req['save_to'] || req('reset')) { $req['save_to'] = 'index_base.html'; }
	foreach ($tmpl_list as $tmpl) {
		$tmpl = urldecode($tmpl);
		$hash['template_file'] = $tmpl;
		$hash['save_to'] = $tmpl;
		if ($req['template_file'] == $tmpl) {
			$list .= "<div><span class=\"quote\" style=\"\">{$tmpl}を</span></div>\n";
		} else {
			$list .= "<div><a href=\"" . script_link($hash) . "\">$tmpl</a></div>\n";
		}
		unset($hash['template_file']);
		if ($tmpl != './template/index_base.html') {
			if ($req['save_to'] == $tmpl || strpos($req['save_to'], $tmpl) != false) {
				$save_to .= "<option selected value=\"$tmpl\">$tmpl</option>\n";
			} else {
				$save_to .= "<option value=\"$tmpl\">$tmpl</option>\n";
			}
		}
	}
	$save_to .= "</select>\n</div>\n";
	$list .= "</div>\n";
	$html .= "<div style=\"display:flex;flex-wrap:wrap;align-items:center;\">\n";
	$html .= "<div style=\"padding:0.5em;\">$list</div>\n";
	//$html .= "<div>を</div>";
	$html .= "<div>\n";
	$html .= "<div style=\"padding:0.2em;\"><input type=\"submit\" name=\"overwrite\" value=\"上書き保存\" /></div>\n";
	$html .= "<div style=\"display:flex;flex-wrap:wrap;align-items:center;\">\n";
	$html .= "<div style=\"padding:0.2em;\">$save_to</div>\n";
	$html .= "<div style=\"padding:0.2em;\">\n<div style=\"padding:0.2em;\"><input type=\"submit\" name=\"saveas\" value=\"に保存\" /></div>\n<div style=\"padding:0.2em;\"><input type=\"submit\" name=\"delete\" value=\"を削除\" /></div></div>";
	$html .= "</div></div></div>\n";
	$template_escape = $template;
	$template_escape = str_replace("<", "&lt;", $template_escape);
	$template_escape = str_replace(">", "&gt;", $template_escape);
	$html .= "<textarea name=\"html\" rows=\"20\">" . $template_escape . "</textarea>";
	$html .= "</form>\n";
	if ($req['template_file'] == 'index_base.html') {
		$html .= "<div>現在選択されているindex_base.htmlが実際に掲示板に使用されるテンプレートファイルです。
		このファイルを編集して「上書き保存」あるいは「index_base.htmlに保存」すると、掲示板の見た目に反映されます。</div>\n
		<div>名前をつけて「に保存」ボタンを押すとtemplateフォルダ内に保存されます。templateフォルダ内のテンプレートの内容をindex_base.htmlに書き込むこともできます。</div>\n";
	}
	$html .= "</div>\n";
	$html = indent_div($html);
	if (req('preview')) {
		global $counter, $counter_format;
		if (isset($counter)) {
			$counter_format = str_replace('[[counter]]', '!counter!', $counter_format);
			$counter = str_replace('!counter!', number_format(intval($counter)), $counter_format);
		}
		$template = str_replace('!add_header_link!', '', $template);
		$template = str_replace('!title!', 'ヘッダのtitleタグに表示される文字', $template);
		$template = str_replace('!header!', 'header内', $template);
		$template = str_replace('!sub_header!', 'sub_header内', $template);
		$template = str_replace('!article_search!', '検索フォームを表示する', $template);
		$template = str_replace('!form!', '以下投稿フォーム', $template);
		$template = str_replace('!field_title!', 'タイトルフィールド内', $template);
		$template = str_replace('!field_writer!', '投稿者フィールド内', $template);
		$template = str_replace('!article_attach!', '添付ファイルを表示する', $template);
		$template = str_replace('!form_help!', '投稿フォームのヘルプ', $template);
		$template = str_replace('!field_comment!', 'コメントフィールド内', $template);
		$template = str_replace('!article_del_button!', '記事削除ボタンを表示', $template);
		$template = str_replace('!main!', '以下記事表示部分', $template);
		$template = str_replace('!article_title!', '記事のタイトル', $template);
		$template = str_replace('!article_date!', '記事の日付', $template);
		$template = str_replace('!article_writer!', '記事の投稿者', $template);
		$template = str_replace('!article_reply!', '返信', $template);
		$template = str_replace('!article!', '記事の内容', $template);
		$template = str_replace('!attach!', '添付ファイル表示', $template);
		$template = str_replace('!footer!', 'footer内', $template);
		$counter = counter_str();
		if (!$counter) { $counter = 0; }
		$template = str_replace('!counter!', number_format($counter), $template);
	}
	$html = preg_replace('/<\/body>/', $html . '</body>', $template);
	print $html;
	exit;
}


function bbs_config() {
	global $script;
	$init_log = file('./init.php');
	foreach ($init_log as $line) {
		if (preg_match('/<\?php/',$line) || preg_match('/\?>/',$line)) { continue; }
		eval($line);
	}
	$hash = array('bbs_admin'=>1,'bbs_admin_login'=>req('bbs_admin_login'));
	$html = "<div style=\"padding:0.5em;\"><a href=\"" . script_link($hash) . "\">戻る</a>  ";
	$hash['edit_template'] = 1;
	$html .= "<a href=\"" . script_link($hash) . "\">テンプレートを編集する</a></div>\n";
	$message = '';
	if (req('clear_cookie')) {
		setcookie("bbs_admin_pass", '', time() - 30);
		setcookie("bbs_cpass", '', time() - 30);
		$message .= "<div style=\"color:crimson;\">クッキーをクリアしました</div>\n";
	} elseif (req('change_pass') && req('new_admin_pass')) {
		if (strlen(req('new_admin_pass')) < 5) { error("パスワードは5文字以上にしてください。",'back'); }
		$new_init_list = array();
		foreach ($init_log as $line) {
			$tmp = $line;
			$tmp = str_replace(' ','',$tmp);
			$ptn = '/^\$crypt_pass=\'/';
			if (preg_match($ptn,$tmp)) {		
				// 入力された管理者用パスワードをcryptして$crypt_passに代入する文字列を生成
				$crypt_pass = encrypt(req('new_admin_pass'));
				$tmp = explode(';',$line);
				$com = array_pop($tmp);
				$new_pass = '$crypt_pass = ' . "'" . $crypt_pass . "';" . $com;
				array_push($new_init_list,$new_pass);
			} else {
				array_push($new_init_list,$line);
			}
		}
		file_put_contents('./init.php', $new_init_list, LOCK_EX);
		$message .= "<div style=\"color:crimson;\">管理者パスワードを変更しました</div>\n";
	}
	if (req('post')) {
		foreach ($_REQUEST as $key=>$val) {
			if (in_array($key,$config_list)) {
				$val = str_replace(array("\r\n","\r","\n"), "\n", $val);
				if ($$key != $val) {
					$tmp = str_replace("<", "&lt;", $val);
					$tmp = str_replace(">", "&gt;", $tmp);
					if (preg_match('/\n/', $val)) {
						$message .= "<div style=\"color:crimson;padding:0.5em;\">$" . "{$key}を<pre style=\"font-weight:bold;\">" . $tmp . "</pre>に変更しました</div>\n";
					} else {
						$message .= "<div style=\"color:crimson;padding:0.5em;\">$" . "{$key}を<div style=\"font-weight:bold;\">" . $tmp . "</div>に変更しました</div>\n";
					}
				}
				$$key = $val;
				if ($key == 'allow_ext_str') {
					list($mt_list,$mn_list) = file_upload('mime_check','');
					$ext_list = explode(',',$val);
					foreach ($ext_list as $ext) {
						if (!isset($mt_list[$ext])) {
							$message .= "<div style=\"color:crimson;\">\$allow_ext_strに" . $ext . "が含まれていますが、\$mt_listが未設定です。function file_uploadで追加してください</div>\n";
						}
						if (!isset($mn_list[$ext])) {
							$message .= "<div style=\"color:crimson;\">\$allow_ext_strに" . $ext . "が含まれていますが、\$mn_listが未設定です。function file_uploadで追加してください</div>\n";
						}
					}
				}
			}
		}
		$new_line = array();
		foreach ($init_log as $line) {
			preg_match('/^\s?\$([^ =]+)/',$line,$match);
			if (isset($match[1]) && in_array($match[1],$config_list)) {
				$tmp = explode(';',$line);
				list($nm,$val) = explode('=',$tmp[0]);
				$nm = trim($nm);
				$test = preg_replace('/^\$/','',$nm);
				$val = $$test;
				$val = str_replace(array("\r\n","\r","\n"), "\n", $val);
				$val = str_replace("\n", '\n', $val);
				$val = str_replace('"','\"',$val);
				$type = gettype($val);
				if (preg_match('/^\d+$/',$val)) {
					
				} else {
					$val = '"' . $val . '"';
				}
				$line = $nm . ' = ' . $val . ';' . end($tmp);
			}
			$new_line[] = $line;
		}
		file_put_contents('./init.php',$new_line,LOCK_EX);
		make_config();
	}
	$html .= "<div>\n";
	$html .= $message;
	$hash = array('bbs_admin'=>req('bbs_admin'),'bbs_config'=>req('bbs_config'),'bbs_admin_login'=>req('bbs_admin_login'));
	$html .= script_form($hash);
	$html .= "<div style=\"padding:0.5em;\"><input type=\"submit\" name=\"post\" value=\"編集する\"></div>\n";
	$count = 0;
	foreach ($init_log as $line) {
		preg_match('/^\s?\$([^ =]+)/',$line,$match);
		if (isset($match[1]) && in_array($match[1],$config_list)) {
			$tmp = $match[1];
			$_ = explode(';',$line);
			$config = $_[0];
			$comment = end($_);
			//list($config,$comment) = explode(';',$line);
			$flen = mb_strwidth($$tmp);
			$fem = intval($flen*0.7);
			if ($fem > 15) {
				$style = " style=\"width:" . $fem . 'em' . ";\"";
			} else {
				$style = "";
			}
			if (!($count % 2)) {
				$back = "background-color:#fff;";
			} else {
				$back = "";
			}
			$html .= "<div style=\"display:flex;flex-wrap:wrap;padding:0.2em;$back\">\n";
			$value = $$tmp;
			$value = str_replace('<','&lt;',$value);
			$value = str_replace('>','&gt;',$value);
			$value = str_replace('"','&quot;',$value);
			if ($fem > 100) {
				$html .= "<div style=\"padding:0.2em;\">$" . $match[1] . " = </div><div style=\"padding:0.2em;\"><textarea cols=\"100\" rows=\"2\" name=\"" . $match[1] . "\" style=\"width:100%\">$value</textarea></div><div style=\"padding:0.2em;\">$comment</div>\n";
			} else {
				$html .= "<div style=\"padding:0.2em;\">$" . $match[1] . " = </div><div style=\"padding:0.2em;\"><input type=\"text\" name=\"" . $match[1] . "\" value=\"" . $value . "\"$style /></div><div style=\"padding:0.2em;\">$comment</div>\n";
			}
			$html .= "</div>\n";
			$count++;
		}
	}
	$html .= "</form>\n";
	$hash = array('bbs_admin'=>req('bbs_admin'),'bbs_config'=>req('bbs_config'),'bbs_admin_login'=>req('bbs_admin_login'));
	$html .= script_form($hash);
	$html .= "<div style=\"display:flex;flex-wrap:wrap;align-items:center;margin-top:2em;\"><div>管理者パスワードを</div><div><input type=\"text\" name=\"new_admin_pass\" value=\"\" /></div><div><input type=\"submit\" name=\"change_pass\" value=\"に変更する\"></div></div>\n";
	$html .= "</form>\n";
	$hash = array('bbs_config'=>req('bbs_config'),'bbs_admin'=>req('bbs_admin'),'bbs_admin_login'=>req('bbs_admin_login'),'clear_cookie'=>1);
	$html .= "<div style=\"display:flex;flex-wrap:wrap;padding:0.2em;\"><div><a href=\"" . script_link($hash) . "\">クッキーをクリア</a></div></div>";
	$html .= "</div>\n";
	return($html);
}



function form() {
	global $title_, $writer_,$comment_,$date_,$id,$bbs_dir,$log,$end,$id_path,$slide_lock,$img_ext,$script,$hash,$hide_form,$upload_error,$field_template,$help_admin, $form_expr, $inspect_mode, $hashed, $tag_list;
	if (!file_exists($bbs_dir)) { mkdir($bbs_dir); }
	$tenpu_list = array();
	$tmpdir = opendir($bbs_dir);
	while ($file = readdir($tmpdir)) {
		if (req('id2') && preg_match('/^' . req('id2') . '/',$file)) {
			if (!preg_match('/thumb\./',$file) && !preg_match('/\.oname/',$file)) {
				$tenpu_list[] = $file;
				$tenpu_mod_list[$file] = filemtime("$bbs_dir/$file");
			}
		}
		if (! preg_match('/^\w{12}\.cgi$/',$file)) { continue; }
		if (filemtime($bbs_dir . '/' . $file) < time() - 60 * $form_expr) {
				// 古いIDファイル(作成から$form_expr分経過)は削除
				unlink($bbs_dir . '/' . $file);
		}
	}
	closedir($tmpdir);
	if (isset($tenpu_mod_list)) {
		asort($tenpu_mod_list);
		$tenpu_list = array_keys($tenpu_mod_list);
	}
	$title = $writer = '';
	$comment = $alert = '';
	$post_id = random_str(12);
	$hash = array();
	if (req('id2') && req('bbs_pass') && !req('posted')) { $hash['id2'] = req('id2'); }
	if (req('noform')) {
		$hash['noform'] = req('noform');
	} elseif (req('edit')) {
		$hash['noform'] = req('edit');
	}
	if (req('page')) { $hash['page'] = req('page'); }
	if (req('item')) { $hash['item'] = req('item'); }
	if (req('sort')) { $hash['sort'] = req('sort'); }
	$hash['page'] = 0;
	if (req('alert')) { $alert = req('alert'); }
	if ($slide_lock) {
		$form = "<div style=\"\" id=\"bbs\" class=\"notprint\">\n" . script_form_file($hash,'bbs','slidelock');
	} else {
		$form = "<div style=\"display:inline-block;\" id=\"bbs\" class=\"notprint\">\n" . script_form_file($hash,'bbs');
	}
	if (!$hide_form && isset($log) && $log) {
		$hash = array('hide_form'=>1);
		foreach (array('id','page','sort','item','noform','show_past','past_nmb') as $key) {
			if (req($key)) { $hash[$key] = req($key); }
		}
		$link = script_link($hash);
		$form .= "<div style=\"display:flex;flex-wrap:wrap;\">\n";
		$form .= "<div style=\"padding-left:1em;\">$alert<a href=\"$link\">■フォームを隠す</a></div>\n";
		$form .= "!alert!";
		$form .= "</div>\n";
	}
	if ($upload_error) {
		$form .= "<div>" . $upload_error . "</dvi>\n";
	}
	$rewrite = 0;
	if (isset($hashed[req('id2')]) && $hashed[req('id2')] && req('bbs_pass')) {
		if (password_verify(req('bbs_pass'),$hashed[req('id2')])) {
			$comment = $comment_[$hashed[req('id2')]];
			$title = $title_[$hashed[req('id2')]];
			$writer = $writer_[$hashed[req('id2')]];
			$form .= "<input type=\"hidden\" name=\"rewrite\" value=\"1\" />\n";
			$form .= "<input type=\"hidden\" name=\"hashed\" value=\"" . $hashed[req('id2')] . "\" />\n";
			$rewrite = 1;
		}
	} elseif (req('res')) {
		foreach ($log as $line) {
			$tmp = explode('<>',$line);
			if ($tmp[0] == req('id2')) {
				$title = $tmp[2];
				$comment = $tmp[4];
				if (!preg_match('/^Re:/',$title)) { $title = "Re:" . $title; }
				$tmp2 = explode('<br />',$comment);
				$tmp_ar = array();
				foreach ($tmp2 as $_) {
					$_ = preg_replace('/\[file\d+\]/', '', $_);
					$tmp_ar[] = '&gt;' . $_;
				}
				$comment = join('<br />',$tmp_ar);
				break;
			}
		}
	}
	$form .= "<input type=\"hidden\" name=\"post_id\" value=\"" . $post_id . "\" />\n";
	if (!file_exists($bbs_dir . '/' . $post_id . '.cgi')) {
		file_put_contents($bbs_dir . '/' . $post_id . '.cgi','',LOCK_EX);
		if ($inspect_mode) {
			if (!is_dir($bbs_dir . '/inspect')) { mkdir($bbs_dir . '/inspect'); }
			if (isset($_SERVER['REMOTE_ADDR'])) { $ip = $_SERVER['REMOTE_ADDR']; } else { $ip = ''; }
			if (isset($_SERVER['HTTP_REFERER'])) { $referer = $_SERVER['HTTP_REFERER']; } else { $referer = ''; }
			if (isset($_SERVER['HTTP_USER_AGENT'])) { $agent = $_SERVER['HTTP_USER_AGENT']; } else { $agent = ''; }
			$log = "time=" . time() . "<>post_id=" . $post_id . "<>ip=" . $ip . "<>referer=" . $referer . "<>agent=" .  $agent . "\n";
			$show_form_path = $bbs_dir . '/inspect/show_form.cgi';
			file_put_contents($show_form_path, $log, FILE_APPEND | LOCK_EX);
			if (filesize($show_form_path) > 1024*1000) {
				for ($i=1;$i<=100;$i++) {
					$new_path = str_replace('.cgi','_' . $i . '.cgi', $show_form_path);
					if (!file_exists($new_path) || filemtime($new_path) < time() - 3600*24*100) {
						rename($show_form_path, $new_path);
						break;
					}
				}
			}
		}
	}
	$comment = str_replace("<br />","|n|",$comment);
	if ($rewrite) {
		$del_button = "&nbsp;&nbsp;&nbsp;<input id=\"delete\" type=\"submit\" name=\"bbs_delete\" value=\"削除\" />";
	} else {
		$del_button = '';
	}
	$hash = array();
	if (req('noform')) {
		$hash['noform'] = req('noform');
	} elseif (req('edit')) {
		$hash['noform'] = req('edit');
	}
	if (req('sort')) { $hash['sort'] = req('sort'); }
	if (req('item')) { $hash['item'] = req('item'); }

	$help_link = "<wbr><a href=\"" . script_link($hash,'bbs') . "&amp;bbs_help=1\">ヘルプ</a>";
	if (preg_match('/^<strong>(.+)<\/strong>$/',$writer,$match)) {
		$writer = $match[1];
	} else {
		$writer = '';
	}
	if (isset($_COOKIE['bbs_writer_pass'])) { $cwpass = $_COOKIE['bbs_writer_pass']; } else { $cwpass = ''; }
	if ($cwpass) {
		$field_template = preg_replace('|<input[^/>]+name="password"[^/>]+style="([^"]+)"[^/]*/?>|','<input type="password" name="password" style="$1" value="' . $cwpass . '" />',$field_template);
		$field_template = preg_replace('|<input[^/>]+name="password"[^/>][^/]*/?>|','<input type="password" name="password" value="' . $cwpass . '" />',$field_template);
	}
	$attach_str = '';
	if ($rewrite && $tenpu_list) {
		$str = '';
		foreach ($tenpu_list as $file) {
			$ext = pathinfo($file,PATHINFO_EXTENSION);
			if ($ext == 'count') { continue; }
			$hash['id2'] = req('id2');
			$hash['del_file'] = $file;
			$hash['bbs_pass'] = req('bbs_pass');
			//$hash['hashed'] = req('hashed');
			$link = script_link($hash);
			$nmb = '';
			if (preg_match('/_(\d+)/', $file, $match)) {
				$nmb = $match[1];
			}
			$str .= "<div style=\"margin:5px;\"><a href=\"$link\">削除</a><br />";
			if (preg_grep('/' . $ext . '/i',$img_ext)) {
				$thumb = str_replace(".$ext","thumb.$ext",$file);
				if (file_exists($bbs_dir . '/' . $thumb)) {
					$str .= "<img src=\"{$bbs_dir}/$thumb\" alt=\"$file\" /> ";
				} else {
					$str .= "<img src=\"{$bbs_dir}/$file\" alt=\"$file\"  /> ";
				}
			} else {
				if (file_exists("{$bbs_dir}/$file" . '.oname')) {
					$oname = file_get_contents("{$bbs_dir}/$file" . '.oname');
					$str .= "<a title=\"$file\">$oname</a> ";
				} else {
					$str .= "$file ";
				}
			}
			if ($nmb) {
				$str .= "<br /><span title=\"この文字列の位置に添付ファイルが表示されます\">[file$nmb]</span>";
			}
			$str .= "</div>\n";
		}
		if ($str) { $attach_str = "<div style=\"display: flex;flex-wrap:wrap;\">$str</div>\n"; }
	}
	$form_help = '';
	if ($tag_list[0]) { $form_help = "<span style=\"font-size:80%;margin-left:1em;\"><b>" . join('、', $tag_list) . "</b>タグが使用できます。タグ内に入れられるのはタグ名と/のみです。</span>\n"; }
	$field = str_replace('!field_title!',$title,$field_template);
	$field = str_replace('!field_writer!',$writer,$field);
	$field = str_replace('!field_comment!',$comment,$field);
	$field = str_replace('!article_attach!',$attach_str,$field);
	$field = str_replace('!form_help!',$form_help, $field);
	$field = str_replace('!article_del_button!',$del_button,$field);
	$form .= $field;
	$form .= "</form>\n";
	$form .= "</div>\n";
	$search_form = '';
	if (file_exists($id_path)) {
		if ($hide_form && !$upload_error) {
			$link = $script . "?hide_form=0";
			foreach (array('id','page','sort','item','noform','show_past','past_nmb') as $key) {
				if (req($key)) { $link .= "&amp;{$key}=" . req($key); }
			}
			$form = "<div style=\"display:flex;flex-wrap:wrap;\">";
			$form .= "<div style=\"padding-left:1em;\">$alert<a href=\"$link\">■フォームを表示する</a></div>\n";
			$form .= "</div>\n";
		}
		$form .= "<div style=\"margin:0.5em;background-color:#fff;\">\n";
		$bbs_keyword = req('bbs_keyword');
		if (req('clear')) { $bbs_keyword = ''; }
		$search_form = script_form_file($hash,'bbs');
		$search_form .= "<div style=\"display:flex;flex-wrap:wrap;justify-content: flex-end;align-items:center;\">";
		$search_form .= "<div style=\"padding:0.2em;font-size:80%;\">キーワード <input type=\"text\" name=\"bbs_keyword\" value=\"$bbs_keyword\" style=\"width:12em;\" /></div>\n";
		$search_form .= "<div style=\"padding:0.2em;\"><input type=\"submit\" name=\"search\" value=\"検索する\" /></div>\n";
		if ($bbs_keyword) {
			$search_form .= "<div style=\"padding:0.2em;\"><input type=\"submit\" name=\"clear\" value=\"クリア\" /></div>\n";
		}
		$search_form .= "</div>\n";
		$search_form .= "</form>\n";
		$form .= "</div>\n";
		$hash['bbs_admin'] = 1;
		$admin_link = script_link($hash,'bbs');
	}
	$form = str_replace("\n","|n|",$form);
	return array($form,$search_form);
}




function footer() {
	global $debug_mode,$debug;
	$footer = '';
	time_check('footer表示開始');
	$footer .= "<div class=\"notprint\" style=\"text-align:right;margin-right:1em;white-space:nowrap;\">\n";
	$footer .= '!admin!';
	$footer .= "</div>\n";
	if ($debug_mode) {
		$footer .= "<div class=\"notprint\" style=\"padding:1em;background-color:#ddffff;color:#000000;\">\n";
		if (isset($debug)) { $footer .= $debug; }
		$keys = array_keys($_REQUEST);
		foreach ($keys as $i) {
			if (req("$i")) { $footer .= '$_REQUEST[' . $i . '] = ' . $_REQUEST[$i] . "<br />\n"; }
		}
		$footer .= "<div>クッキー表示</div>";
		foreach ($_COOKIE as $key=>$val) { $footer .= "\$_COOKIE[$key]→" . $_COOKIE[$key] . "<br />\n"; }
		$footer .= "</div>\n";
	}
	return $footer;
}



function user_id() {
	global $bbs_dir;
	$ip = $_SERVER['REMOTE_ADDR'];
	$timestamp = date("Y-m-d");
	if (file_exists($bbs_dir . '/' . 'bbs_seed.cgi')) {
		$secret = file_get_contents($bbs_dir . '/' . 'bbs_seed.cgi');
	} else {
		$secret = random_str(10);
		file_put_contents($bbs_dir . '/' . 'bbs_seed.cgi',$secret,LOCK_EX);
	}
	$id_hash = hash_hmac("sha256", $timestamp.$ip, $secret);
	$id_base64 = base64_encode($id_hash);
	$id = substr($id_base64, 0, 10);
	return $id;
}


function redirect($jump) {
	header("Location: $jump", true, 301); exit(); 
}


function spam_log($sec = '') {
	global $bbs_dir,$max_log,$max_past;
	$comment = req('comment');
	$comment = str_replace("\r\n","\n",$comment);
	$comment = str_replace("\r","\n",$comment);
	$comment = tag_convert($comment);
	$comment = str_replace(">\n",">",$comment);
	$comment = str_replace("\n","<br />",$comment);
	$remote_addr = $remote_host = $user_agent = '';
	if (isset($_SERVER['REMOTE_ADDR'])) { $remote_addr = $_SERVER['REMOTE_ADDR']; }
	if (isset($_SERVER['REMOTE_HOST'])) { $remote_host = $_SERVER['REMOTE_HOST']; }
	if (!$remote_host) { $remote_host = gethostbyaddr($remote_addr); }
	if (isset($_SERVER['HTTP_USER_AGENT'])) { $user_agent = $_SERVER['HTTP_USER_AGENT']; }
	$line = join('<>',array('',time(),req('title'),req('writer'),$comment,req('hashed'),$sec,$remote_addr,$remote_host,$user_agent,req('post_id'))) . "\n";
	$spam_path = $bbs_dir . '/bbs_spamlog.cgi';
	file_put_contents($spam_path,$line,FILE_APPEND | LOCK_EX);
	$log = file($spam_path);
	if (isset($log) && count($log) >= $max_log) {
		$past_log = array_splice($log,0,(count($log) - $max_log));
		$file_nmb = 1;
		while (1) {
			$past_path = preg_replace('/\.cgi$/','_' . $file_nmb . '.cgi',$spam_path);
			if (!file_exists($past_path)) {
				$max_nmb = $file_nmb - 1;
				if ($max_nmb < 1) { $max_nmb = 1; }
				$past_path = preg_replace('/\.cgi$/','_' . $max_nmb . '.cgi',$spam_path);
				break;
			}
			$file_nmb++;
		}
		if (file_exists($past_path) && count(file($past_path)) >= $max_past) {
			$past_path = preg_replace('/\.cgi$/','_' . ($max_nmb + 1) . '.cgi',$spam_path);
		}
		file_put_contents($past_path,$past_log,FILE_APPEND | LOCK_EX);
		file_put_contents($spam_path,$log,LOCK_EX);
	}
}


function jtruncate($str,$n) {
	if ($n < 2) { return ; }
	if (mb_strwidth($str) <= $n) { return $str ; }
	$substr = mb_strimwidth($str,0,$n) . '...';
	return $substr;
}


function encrypt($inpw) {
	if (phpversion() >= 5.5) {
		$encrypt = password_hash($inpw,PASSWORD_DEFAULT);
	} else {
		$encrypt = crypt($inpw,'');
	}
	return($encrypt);
}



//$start_m = microtime(); $start = time();
function time_check($pnt) {
	global $start_s,$start_ms;		//スクリプト開始時の秒、マイクロ秒
	global $row_nmb;
	if (! isset($start_s)) {
		$start_s = time(); list($start_ms) = explode(' ',microtime());
	}
	global $last_s,$last_ms,$last_pnt,$time_checked,$debug;
	if (! isset($last_s)) {
		$last_s = $start_s;$last_ms = $start_ms;
	}
	list($lap_ms) = explode(' ',microtime());
	$lap_s = time();
	$total_s = ($lap_s - $start_s) + ($lap_ms - $start_ms);
	$lap = ($lap_s - $last_s) + ($lap_ms - $last_ms);
	if (! isset($time_checked) || ! $time_checked) {
		$debug = "";
		$time_checked = 1;
		$row_nmb = 0;
	}
	if (! isset($last_pnt)) {
		$last_pnt = date("Y/m/d H:i:s",$start_s) . '開始';
	}
	$row_col = '';
	if (($row_nmb % 2) == 0) {
		$row_col = "background-color:#ffffff;";
	}
	$bt = debug_backtrace();
	$line = $bt[0]['line'];
	$color = '';
	if ($lap > 0.1) {
		$color = "color:crimson;";
	} elseif ($lap > 0.01) {
		$color = "color:#bb4400;";
	} elseif ($lap > 0.001) {
		$color = "color:black;";
	} elseif ($lap > 0.0001) {
		$color = "color:#0022ff;";
	} else {
		$color = "color:#00aaff;";
	}
	$debug .= "<div style=\"display:flex;flex-wrap:wrap;$row_col$color\">\n";
	$debug .= "<div style=\"width:11em;\"><span style=\"font-size:80%\">" . $last_pnt . "</span></div>";
	$debug .= "<div style=\"width:2em;\">→</div><div style=\"width:12em;\"><span style=\"font-size:80%\">" . $pnt . '(' . $line . '行)</span></div>';
	$debug .= "<div style=\"width:10em;\">ラップ " . index_to_decimal(round($lap, 6)) . "秒</div>";
	$debug .= "<div style=\"width:11em;\">(トータル " . round($total_s,6) . "秒)</div>\n</div>\n";
	$row_nmb++;
	$last_s = $lap_s;
	$last_ms = $lap_ms;
	$last_pnt = $pnt;
}


function index_to_decimal($str){
	if( preg_match('@\.(\d+)E\-(\d+)@',$str,$matches) ){
		$digit = strlen($matches[1])+$matches[2];
		$format  = "%.".$digit."f";
		$str     = sprintf($format,$str);
		return $str;
	}
	return $str;
}


function script_link($hash = array()) {
	global $script;
	$str = $script;
	$first = 1;
	foreach ($hash as $key=>$val) {
		if ($first) {
			$str .= "?$key=$val";
		} else {
			$str .= "&amp;$key=$val";
		}
		$first = 0;
	}
	return $str;
}


function script_form($hash = array(), $jump = '') {
	global $script;
	$str = "<form action=\"$script#$jump\" method=\"post\" style=\"margin:0\">\n";
	foreach ($hash as $key=>$val) {
		$str .= "<input type=\"hidden\" name=\"$key\" value=\"$val\" />\n";
	}
	return $str;
}

function script_form_file($hash = array(), $jump = '', $id = '') {
	global $script;
	if ($id) { $id = " id=\"$id\""; }
	$str = "<form$id action=\"$script#$jump\" method=\"post\" style=\"margin:0;\" enctype=\"multipart/form-data\">\n";
	foreach ($hash as $key=>$val) {
		$str .= "<input type=\"hidden\" name=\"$key\" value=\"$val\" />\n";
	}
	return $str;
}


function thumb($url,$width) {
	preg_match('/\.(.{1,4}$)/',$url,$match);
	$ext = $match[1];
	// 元画像のファイルサイズを取得
	list($image_w, $image_h) = getimagesize($url);
	$thumb_path = preg_replace('/(\..{2,4}$)/','thumb$1',$url);
	if ($image_w < $width) {
		copy($url,$thumb_path);
		return;
	}
	//元画像の比率を計算し、高さを設定
	$proportion = $image_w / $image_h;
	$height = $width / $proportion;
	//高さが幅より大きい場合は、高さを幅に合わせ、横幅を縮小
	if($proportion < 1){
	$height = $width;
	$width = $width * $proportion;
	}
	 
	// サイズを指定して、背景用画像を生成
	$width = intval($width);
	$height = intval($height);
	$canvas = imagecreatetruecolor($width, $height);
	
	// ファイル名から、画像インスタンスを生成
	if (in_array($ext,array('gif','GIF'))) {
		$image = imagecreatefromgif($url);
	} elseif (in_array($ext,array('jpg','JPG'))) {
		$image = imagecreatefromjpeg($url);
	} elseif (in_array($ext,array('png','PNG'))) {
		$image = imagecreatefrompng($url);
	} elseif (in_array($ext,array('bmp','BMP'))) {
		if (phpversion() >= 7.2) {
			$image = imagecreatefrombmp($url);
		} else {
			include "./lib/ImageCreateFromBMP.php";
			$image = ImageCreateFromBMP_($url);
		}
	} else {
		return;
	}
	// 背景画像に、画像をコピーする
	imagecopyresampled($canvas,  // 背景画像
	$image,   // コピー元画像
	0,        // 背景画像の x 座標
	0,       // 背景画像の y 座標
	0,        // コピー元の x 座標
	0,        // コピー元の y 座標
	$width,   // 背景画像の幅
	$height,  // 背景画像の高さ
	$image_w, // コピー元画像ファイルの幅
	$image_h  // コピー元画像ファイルの高さ
	);
	
	// 画像を出力する
	if (in_array($ext,array('gif','GIF'))) {
		imagegif($canvas,$thumb_path);
	} elseif (in_array($ext,array('jpg','JPG'))) {
		imagejpeg($canvas,$thumb_path,100);
	} elseif (in_array($ext,array('png','PNG'))) {
		imagepng($canvas,$thumb_path,3);
	} elseif (in_array($ext,array('bmp','BMP'))) {
		//imagewbmp($canvas,$thumb_path,100);
		imagebmp($canvas,$thumb_path,100);
	}
	 
	// メモリを開放する
	imagedestroy($canvas);
}


function download() {
	$file = req('file');
	$file_name = req('name');
	$file_name = str_replace(' ','_',$file_name);
	if (file_exists($file)) {
		header('Content-Description: File Transfer');
		header('Content-Type: application/octet-stream');
		if (req('name')) {
			header('Content-Disposition: attachment; filename='. $file_name);
		} else {
			header('Content-Disposition: attachment; filename='.basename($file));
		}
		header('Expires: 0');
		header('Cache-Control: must-revalidate');
		header('Pragma: public');
		header('Content-Length: ' . filesize($file));
		readfile($file);
		$count_file = $file . '.count';
		file_put_contents($count_file,'1',FILE_APPEND | LOCK_EX);
		exit;
	}
}


// date2("Y/m/d H:i:s",$tm)のように使用	$tmはエポック関数でも日付文字列でもOK
function date2($format,$tm) {
	if (preg_match('/^\d+$/',$tm)) {
		$tm = $tm - 0;
	}
	if (gettype($tm) == 'integer') {
		$tstr = date("Y/m/d H:i:s",$tm);
		$d = date_create($tstr);
	} else {
		$d = date_create($tm);
	}
	return date_format($d, $format);
}


function tag_convert($html,$tag_list = array()) {
	if (!$tag_list) { global $tag_list; }
	$html = str_replace("<","&lt;",$html);
	$html = str_replace(">","&gt;",$html);
	$from = $html;
	foreach ($tag_list as $tag) {
		$ptn = '/&lt;(' . $tag . ')&gt;([\s\S]*?)&lt;\/(' . $tag . ')&gt;/';
		$ptn2 = '<$1>$2</$3>';
		$html = preg_replace($ptn,$ptn2,$html);
	}
	$to = $html;
	return($html);
}


function show_tag($html) {
	global $tag_list;
	foreach ($tag_list as $tag) {
		$ptn = '/(&lt;|<)(' . $tag . ')(&gt;|>)([\s\S]*?)(&lt;|<)\/(' . $tag . ')(&gt;|>)/';
		$ptn2 = '<$2>$4</$6>';
		if (preg_match('/^pre$/i', $tag)) {
			preg_match_all($ptn, $html, $match);
			$out_pre_list = preg_split($ptn, $html);
			$count = 0;
			foreach ($match[4] as $in_pre) {
				// preタグ内はタブを元に戻す
				$match[4][$count] = str_replace(str_repeat("&nbsp;",8),"\t",$in_pre);
				$match[4][$count] = str_replace(str_repeat("&nbsp;",4),"    ",$in_pre);
				$count++;
			}
			$new_html = '';
			$count = 0;
			foreach ($out_pre_list as $out_pre) {
				$new_html .= $out_pre;
				if (isset($match[4][$count])) { $new_html .= "<$tag>" . $match[4][$count] . "</$tag>"; }
				$count++;
			}
			$html = $new_html;
		} else {
			$html = preg_replace($ptn,$ptn2,$html);
		}
	}
	return($html);
}



function article_id() {
	global $id;
	//if (! isset($id)) {
//	/*	デバッグ用
	$logs = debug_backtrace();
	$str = '';
	$str .= "\$id=$id";
	foreach ($logs as $log) {
		$base = basename($log['file']);
		$str .= "  file=" . $base;
		$str .= "  line=" . $log['line'];
		$str .= "  function=" . $log['function'];
	}
	$str .= "\n";
//	*/
	if (! $id) {
		if (req('noform')) {
			$id = req('noform');
		} elseif (req('edit')) {
			$id = req('edit');
		}
	}
	if ($id == 'all') { $id = ''; }
	return $id;
}


function article_dir($id) {
	global $script,$datadir;
	if ($id) {
		$id_dir = join('/',array($datadir,$id));
		return $id_dir;
	}
}

function autolink($str) {
	$pattern = '/((?:https?|ftp):\/\/[-_.!~*\'()a-zA-Z0-9;\/?:@&=+$,%#]+)/';
	$replace = '<a href="$1" target=\"_blank\">$1</a>';
	$str    = preg_replace( $pattern, $replace, $str );
	return($str);
}

function head() {
	global $graph_str,$css;
	if (!isset($css)) { $css= ''; }
	header("Content-type: text/html; charset=UTF-8");
	$header_flag = 1;
	global $title,$white_hover,$header_flag;
	$header_flag = 1;
	$title = isset($title) ? $title : '';
	$style = '<link rel="STYLESHEET" type="text/css" href="https://unpkg.com/ress/dist/ress.min.css" />
	<link rel="STYLESHEET" type="text/css" media="screen" href="bbs.css" />
';
	$style .= "<link rel=\"STYLESHEET\" type=\"text/css\"  href=\"./lib/jslideLock/slidelock.css\" />\n";
	time_check('header出力');
	print <<<EOD
<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="ja" lang="ja">
<head>
<meta http-equiv="content-type" content="text/html; charset=utf-8" />
<meta http-equiv="Content-Script-Type" content="text/javascript" /> 
<meta http-equiv="Content-Style-Type" content="text/css" /> 
<meta name="viewport" content="width=device-width, initial-scale=1, minimum-scale=1, maximum-scale=1, user-scalable=no" />
$style
<title>$title</title>
<link rel="SHORTCUT ICON" href="../favicon.ico" />
<script type="text/javascript" src="./lib/cmanImgPop.js"></script>
<script type="text/javascript" src="https://ajax.aspnetcdn.com/ajax/jQuery/jquery-1.4.2.min.js"></script>
<script type="text/javascript" src="https://ajax.aspnetcdn.com/ajax/jquery.ui/1.8.21/jquery-ui.js"></script>
<script type="text/javascript" src="./lib/jslideLock/jquery.slideLock.js"></script>
<script type="text/javascript" src="./lib/jslideLock/slideLock.js"></script>
<style type="text/css">
<!--
body {
	margin-left:0px;
	margin-right:0px;
	margin-top:0px;
	margin-bottom:0px;
	font-family: "メイリオ", Meiryo, "ＭＳ Ｐゴシック", "MS PGothic", Arial, "ヒラギノ角ゴ ProN W3", "Hiragino Kaku Gothic ProN", sans-serif;
}
textarea,input,pre {
	font-family: "メイリオ", Meiryo, "ＭＳ Ｐゴシック", "MS PGothic", Arial, "ヒラギノ角ゴ ProN W3", "Hiragino Kaku Gothic ProN", sans-serif;
}

rt {
	font-size:60%;
}

td {
	line-height:1.3em;
}
@media print{ 
	.button{ 
		display: none; 
	} 
	input{ 
		display: none; 
	} 
	div.notprint{ 
		display: none; 
	} 
	div.tab{ 
		display: none; 
	} 
	td.notprint{ 
		display: none; 
	} 
	span.notprint{ 
		display: none; 
	} 
	table.notbreak {
		display:block;
	}
}
.cal {
	font-family:Verdana,Helvetica,Arial;
}
.block {
   page-break-inside: avoid;
}
table.notbreak {
	page-break-inside: avoid;
	font-size:130%;
	
}
.tab {
  position: absolute;
  top: 3px;
  left: 6px;
  background-color: transparent;
}
$css
-->
</style>
EOD;
	if (isset($graph_str)) { print $graph_str; }
	global $pulldown;
	print $pulldown;
	print "</head>\n";
	global $body;
	if ($body) {
		print $body;
	} else {
		print "<body>\n";
	}
}

function error($mes) {
	global $header_flag;
	if (!isset($header_flag) || ! $header_flag) { head(); }
	print "<div style=\"margin:0.5em\">\n";
	print "<h2>エラー</h2>\n";
	print "<div>$mes</div>\n";
	print "<div><a href=\"javascript:history.back();\">戻る</a></div>\n";
	print "</div>\n";
	footer();
	exit();
}

function user_agent($user_agent) {
	$os = '';
	if (preg_match('/Windows\s*NT\s*([0-9.]+)/',$user_agent,$match)) {
		if ($match[1] == 6.2) {
			$os = 'Windows 8';
		} elseif ($match[1] == 6.1) {
			$os = 'Windows 7';
		} elseif ($match[1] == 10) {
			$os = 'Windows 10';
		}
	}
	return array($os);
}
